	page	80,132
	title	bridge

;-------------------------------------------------------	
; this is a terminal emulation program 
;
;
;history 
;
;2/5/85		version 1.0
;
;2/22/85	version 1.2
; 
;2/27/85	revised 1.30	
;
;3/1/85		revised 1.40	initial the sio at the end 
;
;3/28/85	revised 1.50	remove set_sio routine in init_sio
;-------------------------------------------------------
;address of 7201 channel a,for keyboard int
key_data	equ	10h		;data register
key_cmd		equ	12h		;command register
;
;address of 7201 channel b, for sio  
sio_data	equ	11h
sio_cmd		equ	13h
;

video_int	equ	10h		
sio_int		equ	14h
key_int		equ	16h
int_7201	equ	74h		;7201 hardware int
sio_hw_int	equ	7fh		;sio hardware int
func_call	equ	21h
out_xoff	equ	01h		;remote side no ready to receive
sio_xoff	equ	02h		;host no ready to receive
comin_busy	equ	04h		;indicate another comin been served
eoi		equ	20h		;enable 8059 int
ack_port	equ	08h		;qx16 port
;ack_port	equ	20h		;ibm port
timeout		equ	80h
data_ready	equ	01h		;sio receive a char
dsr_flag	equ	20h		;data set ready	
;
;some ascii code difinition
xoff_char	equ	13h
xon_char	equ	11h
cont_x		equ	18h
cont_p		equ	10h
esc		equ	1bh
tab_num		equ	09h		;tab to tab is 9 chars
;
;
KEYM_HOLD	EQU	08H

data	segment at 0


	ORG	415H
PRTSC_FLAG	DB	?
HOLDING		DB	?
;
	ORG	418H
KEYS_FLX	DB	?
;
	org	41ah
buffer_head	dw	?		;pointer to head of keyboad buffer
buffer_tail	dw	?		;pointer to tail of keyboad buffer

	org	410h
EQUIP_FLAG	DW	?
	org	449h
CRT_MODE	DB	?
CRT_COLS	DW	?
CRT_LEN		DW	?
CRT_START	DW	?
CURSOR_POSN	DW	8 DUP(?)
CURSOR_MODE	DW	?
ACTIVE_PAGE	DB	?	;current page being displayed
ADDR_6845	DW	?
CRT_MODE_SET	DB	?
CRT_PALETTE	DB	?

;
data	ends

;

code	segment
	assume	cs:code,ds:code,es:code,ss:code

;main program start here

	org	100h
start:	
	jmp	main
;

;
;data	area
;
com_flag	db	0

print_on	db	0		;if set,print tty
;
; sio buffer
;
sio_full	equ	511		;the numbers chosed according to
xoff_1		equ	384		;vt 100 convention
xoff_2		equ	490
xon_1		equ	64
sio_head	dw	offset sio_start
sio_tail	dw	offset sio_start
sio_count	dw	0	
sio_start	db	sio_full+1 dup (?)
sio_end	equ	$
;
; 
VECTOR74	DD	?
chainint	dd	?		;location to save the timer int vector
str0		db	esc,'[2J$'	;esc sequence for clear screen	

;main program start here
main:
	cld
;
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
;
	call	clear_screen		;clear the screen
	call	dsp_status
	call	ibm_flsh		;flash key board buffer
	call	set_com			;setup communication
wait_1:
	call 	com_in			;wait to receive a char from sio
	call	com_out
	jnc	wait_1			;is it a exit
	call	to_dos

;
;terminate the program and return to the dos
to_dos:
;
	call	clear_screen
	cli
	mov	dx,word ptr [chainint]	;set SIO int vector to original value
	mov	ds,word ptr [chainint+2]
	mov	al,sio_hw_int
	mov	ah,25h
	int	func_call
;
	call	set_sio			;initial sio by calling bios
	mov	ax,4c00h		;terminate the program 
	int	func_call


; clear the screen
clear_screen	proc	near
	mov	ax,0600h	
	mov	bh,attr
	xor	cx,cx
	mov	dx,184fh
	int	video_int
;
	mov	ah,02			;set cursor to last line
	xor	bh,bh
	mov	dx,1800h
	int	video_int
	ret
clear_screen 	endp
;
;display the status line
dsp_status	proc	near
	mov	si,offset status_line
	mov	bx,070h			;set reverse video
	mov	cx,1
	mov	al,[si]
dsp1:
	mov	ah,09			;write char
	int	video_int
	mov	ah,2
	inc	dx
	int	video_int
	inc	si
	mov	al,[si]
	cmp	al,'$'
	jne	dsp1
;set cursor to home position
	mov	ah,02
	xor	dx,dx
	int	video_int
	ret
dsp_status	endp
;


set_com	proc	near
;	call	set_sio
;set sio hardware vector table
	cli
	mov	al,sio_hw_int
	mov	ah,35h			;get sio hardware int vector
	int	func_call
	mov	word ptr [chainint+2],es	;save vetor 
	mov	word ptr [chainint],bx
	mov	dx,offset comin_int	;get new sio hardware vector
	mov	al,sio_hw_int
	mov	ah,25h
	int	func_call
	
	call	init_sio
	ret
set_com	endp
	
;
set_sio	proc	near
	mov	ax,0e3h			;9600, 0ne stopbits ,no par,8 data bits
	mov	dx,0
	int	sio_int
	ret
set_sio	endp
 
;
init_sio	proc	near
	mov	al,18h		;reset sio controller
	out	sio_cmd,al
	nop
	nop
	nop
	mov	al,04		;points to  wr4
	out	sio_cmd,al
	mov	al,44h		; *16 clock, 1 stop bit, parity disable
	out	sio_cmd,al
	mov	al,03h		;points to wr3
	out	sio_cmd,al
	mov	al,0e1h		; r *7 , autoenables, r*enable
	out	sio_cmd,al
	mov	al,05h		;points to wr5
	out	sio_cmd,al	;
	mov	al,0eah		;dtr,rts,t*e enable, t * 7 bits
	out	sio_cmd,al
	mov	al,2		;points to wr2
	out	sio_cmd,al
	mov	al,0		;don't care
	out	sio_cmd,al
	mov	al,10h		;reset ext/status int
	out	sio_cmd,al
	mov	al,01		;points to wr1
	out	sio_cmd,al
	mov	al,18h		;int on all receive chars - don`t care parity
	out	sio_cmd,al
	ret
init_sio	endp
;
com_out	proc	near
	cli
	test	com_flag,out_xoff	;is a xoff received
	sti
	jnz	com1
	mov	cl,curs_buf_cont
	or	cl,cl			;is status buffer empty
	jz	com1a
com0:
	call	chk_curs_buf
	call	send_char
	dec	cl
	jnz	com0
com1a:
	mov	ah,1			; read a char from keyboard
	int	key_int
	jz	com1			;is a key been hit
	xor	ah,ah			;yes ,get the input
	int	key_int
	or 	al,al			;is it a extented code
	jz	com1
	cmp	al,cont_x		;is it a control x 
	stc				;set carry	
	je	com2
	cmp	al,cont_p		;is it print command
	je	com1b
	call	send_char
com1:
	clc
com2:
	ret
com1b:
	not	print_on
	jmp	short com1
com_out	endp	
;
chk_curs_buf	proc	near
	dec	cl
	mov	bx,curs_buf_addr
	mov	ax,[bx]			;get top 2 characters of curs_buf
	inc	bx
	or	al,al
	jnz	ccb1
	inc	bx
	dec	cl
ccb1:	
	mov	curs_buf_cont,cl
	mov	curs_buf_addr,bx	;set new pointer
	call	send_char
	clc
	ret
chk_curs_buf	endp
;
;send a char over the communication line
send_char	proc	near
	push	ax
	mov	dx,0
s1:
	mov	ah,3			;get sio status
	int	sio_int
	test	al,dsr_flag		;is receive side ready
	jz	s1
	pop	ax
	mov	ah,1			;send a char over com line
	int	sio_int
	ret
send_char	endp
;

com_in	proc	near
	cli
	mov	bx,sio_head		;get pointer to head of sio buffer
	cmp	bx,sio_tail		;is sio buffer empty
	sti
	jz	i2			;yes do nothing
	mov	al,[bx]			;get char from buffer 
	and	al,7fh			;mask out the msb
	call	inc_sio_buf		;increment sio pointer
	mov	sio_head,bx
	dec	sio_count		;decrease buffer counter
	test	com_flag,sio_xoff	;is the host privious send a xoff
	jz	i1			;no
	cmp	sio_count,xon_1		;is sio buffer almost empty
	jne	i1			;no, do nothing
	push	ax			;save al
	mov	al,xon_char		;send a xon
	call	send_char
	and	com_flag,not sio_xoff	;reset flag
	pop	ax
; do ansi parser
i1:
	call	ibm_writ
i2:
	ret
com_in	endp
;
; increment a buffer pointer
inc_sio_buf	proc	near
	inc	bx
	cmp	bx,offset sio_end		;at the end of buffer
	jne	i5
	mov	bx,offset sio_start
i5:
	ret
inc_sio_buf	endp
;

comin_int	proc	far
	sti
	push	ds			;save ds
	push	cs
	pop	ds
ASSUME	DS:CODE
	push	ax
	push	bx
	push	dx
	push	si			;save si
	push	bp
;receive a char from communication line
	in	al,sio_data
	mov	bl,al
	mov	al,30h			;error reset
	out	sio_cmd,al
	mov	al,38h			;end of int
	out	key_cmd,al
	mov	al,bl
	cmp	al,xoff_char		;is it a xoff 
	je	t2
	cmp	al,xon_char		;is it a xon
	je	t3
	cmp	sio_count,sio_full	;is sio buffer is full
	je	t1			;yes discard the char, do nothing 
	mov	bx,sio_tail		;pointer to sio buffer
	mov	si,bx			;save the value
	call	inc_sio_buf
	mov	byte ptr [si],al	;store the char
	mov	sio_tail,bx		;increase the pointer
	inc	sio_count		;increase buffer count
	cmp	sio_count,xoff_1	;is the buffer almost full
	je	t6
	cmp	sio_count,xoff_2	;check the buffer second time
	jne	t1
t6:
	mov	al,xoff_char		;send xoff
	call	send_char
	or	com_flag,sio_xoff
t1:
	pop	bp
	pop	si
	pop	dx
	pop	bx
	pop	ax
	pop	ds
;
	stc
	ret	2
t2:
	or	com_flag,out_xoff	;remote side no ready to receive 
	jmp	short t1
t3:
	and	com_flag,not out_xoff	;remote side are ready to receive
	jmp	short t1

comin_int	endp

	
attr_modify_tab	label	byte
	db	0			;all attribute off
	dw	0700h
	db	1			;bold on (high 
	dw	08ffh
	db	4			;underscore on
	dw	01f8h
	db	5			;blink on
	dw	80ffh
	db	7			;revers video on
	dw	70f8h
	db	8			;cancelled on (invisible)
	dw	0088h
	db	30			;black foreground
	dw	00f8h
	db	31			;red foreground
	dw	04f8h
	db	32			;green foreground
	dw	02f8h
	db	33			;yellow foreground
	dw	06f8h
	db	34			;blue foreground
	dw	01f8h
	db	35			;magenta foreground
	dw	05f8h
	db	36			;cyan foreground
	dw	03f8h
	db	37			;white foreground
	dw	07f8h
	db	40			;black background
	dw	008fh
	db	41			;red background
	dw	408fh
	db	42			;green background
	dw	208fh
	db	43			;yellow background
	dw	608fh
	db	44			;blue background
	dw	108fh
	db	45			;magenta background
	dw	508fh
	db	46			;cyan background
	dw	308fh
	db	47			;white background
	dw	708fh
	db	0ffh
;
cmdtabl	db	'f'			;horizontal and vertical position
	dw	hvp			;	esc+"["+x+y+"f" (same as 'cup')
	db	'h'			;set mode
	dw	sm			;	esc+"[="+x+"h" etc.
	db	'l'			;reset mode
	dw	rm			;	esc+"[?7h" etc.
	db	'm'			;special video mode
	dw	sgr			;	esc+"["+x1+x2+..+xn+"m"
	db	'n'			;device status report
	dw	dsr			;	esc+"[6n"
	db	'r'			;set margin
	dw	decstbm
	db	'p'			;keyboad key reassignment
	dw	rak			;	esc+"["+x1+x2+..+xn+"p"
	db	's'			;save cursor position. esc+"[s"
	dw	scp			;	esc+"[s"
	db	'u'			;restore cursor position
	dw	rcp			;	esc+"[u"
	db	'A'			;cursor up y rows
	dw	cuu			;	esc+"["+y+"A"
	db	'B'			;cursor down y rows
	dw	cud			;	esc+"["+y+"B"
	db	'C'			;cursor forward x columns
	dw	cuf			;	esc+"["+x+"C"
	db	'D'			;cursor back x columns
	dw	cub			;	esc+"["+x+"D"
	db	'H'			;direct cursor position at (x,y)
	dw	cup			;	esc+"["+y+x+"H"
	db	'J'			;erase in display
	dw	ed			;	esc+"[2J"
	db	'K'			;erase in line
	dw	el			;	esc+"[K"
	db	'R'			;cursor position report
	dw	cpr			;	esc+"["+x+y+"R"
	db	0ffh			;end of table

cntr_mode	db	?
status_line	db	' ctrl x : return to DOS  |  ctrl p : toggle key to print tty',18 dup (20h),'$'
tab_table	db	0,8,16,24,32,40,48,56,64,72,79
tab_offset	db	0
top_margin	db	0
bot_margin	db	17h
set_origin	db	0
set_mode_data	db	1
str_buf_offset	dw	4
state		dw	offset st1
scrn_mode	db	3
max_column	db	4fh
curs_column	db	0
curs_row	db	0
save_curs_data	dw	0
temp		db	0
esc_para_ptr	db	0
		db	0
curs_buf_cont	db	0
curs_buf_addr	dw	offset str_buf
curs_buf	db	1bh			;escape
		db	5bh			;'['
		db	30h,30h			;cursor row position (ascii)
		db	3bh			;';'
		db	30h,30h			;cursor column position (ascii)
		db	52h			;'R'
		db	0dh			;cr
char		db	0
attr		db	7
scrn_page	db	0
crt_buf_addr	dw	0b800h
crt_page_addr	dw	0
;
; console flush routine (ctrl-c,ctrl-f,ctrl-s inspired)
;

ibm_flsh:
	mov	char,0
	mov	curs_buf_cont,0
	push	ds
	xor	ax,ax
	mov	ds,ax
	assume	ds:data			;initialize keyboad buffer
	mov	byte ptr buffer_head,1eh ;buffer head
	mov	byte ptr buffer_tail,1eh ;buffer tail
	assume	ds:code
	pop	ds
	ret
;
;
chk_str_buf:
	mov	bx,offset str_buf	;bx = string buffer pointer
csb1:	mov	cl,[bx]	
	xor	ch,ch			;cx = string block size
	or	cx,cx			;end block ?
	jz	csb4			;yes, end block
	or	al,al			;null character ?	
	jnz	csb2			;no
	cmp	ax,[bx+1]		
	jmp	short csb3

csb2:	cmp	al,[bx+1]		;fit the char with one of the buffer ?
csb3:	jz	csb5			;yes, fitted 
	add	bx,cx			;no, search next string block
	jmp	csb1

csb4:	or	bx,bx
csb5:	ret
;
yes_cr:
	mov	curs_column,0
	jmp	set_curs_pos
;
write_tty1:
	mov	ah,0eh		;call tty function
	int	video_int
wt_ret:	ret
;
back_space:
	cmp	curs_column,0	;if not left edge of screen, move cursor left
	jz	wt_ret
	dec	curs_column
	jmp     set_curs_pos
;
;
left_tab:
	mov	dx,word ptr curs_column
	cmp	dl,max_column		;is it last column
	je	wt_ret
	mov	bx,offset tab_table
tab1:
	inc	bx
	cmp	dl,[bx]		;is column larger then tab stop
	jae	tab1
	mov	dl,[bx]		;set cursor position
	mov	curs_column,dl
	jmp	set_curs_pos	
;
outchr:	
	cmp	print_on,0	;is ir to print
	jz	char1
	call	print_char
char1:
	cmp	al,0dh		;is it a special char
	ja	write_chr_attr
	cmp	al,0		;is it a null char
	jz	wt_ret		;yes do nothing
	cmp	al,09h		;is it a tab
	jz	left_tab
	cmp	al,0bh		;yes,treat as a lf
	jz	yes_lf
	cmp	al,0ch		;yes treat as a lf
	jz	yes_lf 
	cmp	al,0dh		;carriage return ?
	jz	yes_cr		;yes
	cmp	al,0ah		;line feed ?
	jz	yes_lf		;yes
	cmp	al,7		;bell ?
	jz	write_tty1	;yes
	cmp	al,8		;back space ?
	jz	back_space	;yes

write_chr_attr:
	mov	bx,word ptr attr	;get page and attribute
	mov	cx,1			;1 character
	mov	ah,9			;write chr/attr on screen
	int	video_int
	inc	curs_column		;increment cursor column position,
	mov	al,curs_column		;and if not right edge of screen, jump
	cmp	al,max_column		;set cursor position
	jbe	set_curs_pos
	cmp	set_mode_data,0
	jz	lf0
	dec	curs_column
	ret

lf0:	mov	curs_column,0
yes_lf:	inc	curs_row
	mov	dl,bot_margin
	inc	dl
	cmp	curs_row,dl		;if bottom line of screen,scroll 1 line up
	jb	set_curs_pos
	dec	dl
	mov	curs_row,dl
	call	scroll_up_1		;scroll 1 line up
set_curs_pos:
	mov	dx,word ptr curs_column		
	mov	bh,scrn_page		;screen page	
	mov	ah,2			;set cursor position
	int 	video_int
	ret

scroll_up_1:
	mov	dx,word ptr curs_column	;get row and column
	mov	ah,2			;set cursor position
	mov	bh,0			;page 0
	int	video_int
	mov	ax,0601h		;scroll up one line
scroll_1:
	mov	bh,attr
	xor	cl,cl			;
	mov	ch,top_margin
	mov	dl,max_column
	mov	dh,bot_margin 
	int	video_int
	ret
;
print_char	proc	near
	xor	ah,ah			;call print int
	xor	dx,dx
	int	17h
	ret
print_char	endp

;
; console output routine
;

ibm_writ	proc	near
	mov	si,offset state
	call	word ptr [si]
	ret
ibm_writ	endp
;

;
; state one
;	look for an escape character
;

st1:	cmp	al,1bh			;see if this the first character is esc
	jnz	st11
	mov	word ptr [si],offset st2
	ret

st11:	call	outchr
st12:	mov	word ptr state,offset st1
	ret
		
;
; state twe
;	looks for the "[" character
;
; esc 7, save cursor 
st27:
	jmp	scp
; esc 8, restore cursor
st28:
	jmp	rcp
;
st2:
	cmp	al,'['			;see if a valide state two
	jz	st21
	cmp	al,'='
	jz	st12
	cmp	al,'>'
	jz	st12
	cmp	al,'7'			;is it esc 7 seq
	jz	st27
	cmp	al,'8'			;is it esc 8
	jz	st28
	cmp	al,'D'			;is it esc D sequence
	jz	esc_D
	cmp	al,'E'			;is it a esc E seq
	jz	esc_E
	cmp	al,'M'			;is it a esc M seq
	jz	esc_M
	jmp	st1

st21:	mov	word ptr [si],offset st3
	xor	bx,bx
	mov	word ptr temp,bx	;clear temp and esc para pointer
st22:
	call 	get_pointer		;get buffer pointer
	mov	word ptr [bx],0			;set to zero
	ret
 
;
;move the cursor download one line, without changing the column
;if the active position is at the bottom, a scroll up is performed    
esc_D:
	call	yes_lf
	jmp	st12
;
;move the cursor to the first position of next line
esc_E:
	call	lf0
	jmp	st12
;
;move the position to the preceding line without changing column position
esc_M:
	mov	dh,curs_row
	cmp	dh,top_margin		;is it the first line
	jbe	esc_3			;yes, do scroll down  
	dec	curs_row
	jmp	set_curs_pos2
;
esc_3:
	mov	ax,0701h		;scroll down one row
	call	scroll_1
	jmp	st12
;
; state three
;	entrerd one or more times for parameter passing
;

st3:	cmp	al,';'			;look for decimal # separater
	jnz	st3a			;no, check phase a
st31:	inc	esc_para_ptr
	jmp	short st22

;
; state three a
;	check for a ascii digit
;

st3a:	
	cmp	al,'9'			;still checking for ascii digit
	ja	st3b			;no, it must be a secondery
	cmp	al,'0'			;check for a ascii digit
	jb	st3b			;no, check for secondery command character
	sub	al,30h			;convert to binary
	call	get_pointer
	xchg	[bx],al			;get existing #
	mov	ah,0ah			;scale by 10
	mul	ah
	add	[bx],al			;add to new digit
	ret

;
; state three b
;	wasn't a ascii digit, so check for secondery command
;

st3b:	
	cmp	al,'"'
	jz	st3b2
	cmp	al,'?'
	jz	st3b1
	cmp	al,'='
	jz	st3b1
	cmp	al,27h
	jnz	select_command
st3b2:	mov	word ptr [si],offset st4
	mov	temp,al
st3b1:	ret

;
; state foure
;

st4:	cmp	al,temp
	jnz	st41
	dec	esc_para_ptr
	mov	word ptr [si],offset st3
	ret

st41:	call	get_pointer
	mov	[bx],al
	mov	word ptr [si],offset st4
	jmp	st31

select_command:				;select command vector from table
	mov	bx,offset cmdtabl-3
sc1:	add	bx,3
	cmp	byte ptr [bx],0ffh
	jz	sc3
	cmp	[bx],al
	jnz	sc1
	mov	ax,[bx+1]
	mov	bx,offset str_buf
	add	bx,str_buf_offset
	inc	bx
	mov	cl,[bx]			;get parameter
	xor	ch,ch
	mov	dx,cx			;keep a copy of parameter
	or 	dx,dx
	jnz	sc2
	inc	cx			;set default value to 1
sc2:	jmp	ax
sc3:
	jmp	st11

get_pointer:
	mov	bx,str_buf_offset
	add	bx,word ptr esc_para_ptr
	inc	bx
	cmp	bx,200
	jb	gap1
	dec	esc_para_ptr
	jmp	get_pointer

gap1:	add	bx,offset str_buf
	ret
;
; change cursor data for each command and set cursor position
;

chg_curs_data:
	cmp	[bx],dh
	jz	set_curs_pos2
	add	[bx],dl
	loop	chg_curs_data
set_curs_pos2:
	mov	dx,word ptr curs_column
	xor	bx,bx
	mov	ah,2
	int	video_int
	jmp	st12

;
; set cursor position directry
;

cup:
hvp:	
	mov	ch,cl
	dec	ch
	cmp	set_origin,0		;is origin set
	jnz	cup0
	cmp	ch,top_margin
	jb	set_curs_pos2		;cursor is below top margin
cup0:	
	cmp	ch,bot_margin		;above max row of screen ?
	ja	set_curs_pos2		;yes, not change cursor data
	mov	al,max_column
	mov	cl,[bx+1]		;get column value
	or	cl,cl
	jz	cup1
	dec	cl
cup1:	cmp	cl,al			;under or equel max column # ?
	jbe	cup2			;yes
	mov	cl,al			;no, set max column value
cup2:					;ch=row, cl=column
	mov	word ptr curs_column,cx	;set new cursor position
	jmp	set_curs_pos2

;
; move cursor down n rows
;

cud:	
	mov	dh,bot_margin
	mov	dl,1h
cud1:	
	mov	bx,offset curs_row
	jmp	chg_curs_data

;
; move cursor up n rows
;

cuu:	
	mov	dh,top_margin
	mov	dl,0ffh
	jmp	cud1

;
; move cursor forward n columns
;

cuf:
	mov	dl,1			;for increment column position
	mov	dh,max_column
	jmp	cub1

;
; move cursor backward n columns
;

cub:	
	mov	dx,0ffh			;for decrement column position
cub1:	mov	bx,offset curs_column
	jmp	chg_curs_data

;
; save cursor position
;

scp:	mov	dx,word ptr curs_column
	mov	save_curs_data,dx
	jmp	set_curs_pos2
	
;
; restore cursor position
;

rcp:	mov	dx,save_curs_data
	mov	word ptr curs_column,dx
	jmp	set_curs_pos2

;
; set graphics rendition
;

sgr:	xor	cx,cx
	xchg	esc_para_ptr,cl
	call	get_pointer
	inc	cx
sgr3:	mov	al,[bx]
	push	bx
	mov	bx,offset attr_modify_tab
sgr2:	mov	ah,[bx]
	add	bx,3
	cmp	ah,0ffh
	jz	sgr1
	cmp	ah,al
	jnz	sgr2
	mov	ax,[bx-2]
	and	attr,al
	or	attr,ah
sgr1:	pop	bx
	inc	bx
	loop	sgr3
	jmp	set_curs_pos2

;
; erase in display
;

ed:	
	or	dx,dx			;is parameter 0
	jz	ed0
	dec	dx			;is it 1
	jz	ed1
;esc[2J, erase all screen 
	mov	dh,17h
	xor	cx,cx
	mov	word ptr curs_column,cx
	jmp	scroll_page_up
;esc[0J or esc[J, erase from the current position to the end of sereen
ed0:
	mov	al,17h			;max column
	sub	al,curs_row
	mov	cl,max_column
	inc	cl		
	mul	cl
	sub	cl,curs_column
ed0a:
	xor	ch,ch
	add	cx,ax
	mov	bx,word ptr attr
	mov	ax,0920h		;write blanks
	int 	video_int
	ret
;esc[1J , erase from the start of the screen to the current positon
ed1:
	xor	ah,ah
	mov	al,curs_row		;get current row
	or	al,al			;is it row 0
	jz	ed1a
	mov	cl,max_column
	inc	cl
	mul	cl
ed1a:
	mov	cl,curs_column
	inc	cl
	jmp	short ed0a	
;
; erase in line
;

el:	
	or	dx,dx			;is parameter 0
	jz	el0
	dec	dx			;is it 1
	jz	el1
;esc[2K  erase all of the line
	mov	ch,curs_row		;get the current row
	mov	dh,ch
	xor	cl,cl
	mov	dl,max_column
	jmp	ela	
;esc[0K or esc[K, erase from the current positon to the end of line 
el0: 
	mov	cx,word ptr curs_column
	mov	dh,ch
scroll_page_up:
	mov	dl,max_column
ela:
	mov	bh,attr
	mov	ax,600h
	int	video_int
	jmp	set_curs_pos2
;esc[1K, erase from the start of the line to the current position
el1:
	mov	dx,word ptr curs_column
	mov	ch,dh
	xor	cl,cl
	jmp	ela
 		

;
; device status report
;

dsr:	
	mov	curs_buf_cont,9
	mov	al,curs_column
	call	chg_bin_asc
	mov	word ptr curs_buf+5,ax
	mov	al,curs_row
	call	chg_bin_asc
	mov	word ptr curs_buf+2,ax
	mov	curs_buf_addr,offset curs_buf

;
; cursor position report
;

cpr:	jmp	st12

;
; change binary to ascii
chg_bin_asc:
	mov	dl,0ah
	inc	al
	xor	ah,ah
	div	dl
	add	ax,3030h
	ret

;
; set top and bottom margins
decstbm:
	mov	ch,[bx+1]
	cmp	ch,cl
	jbe	stbm1
	dec	ch
	cmp	ch,17h			;is it above max_row
	jbe	stbm2
	mov	ch,17h
stbm2:
	dec	cl
	mov	top_margin,cl
	mov	bot_margin,ch
stbm1:
	mov	dh,top_margin		;cursor is in home position
	dec	dh
	xor	dl,dl
	mov	word ptr curs_column,dx
	jmp	set_curs_pos2
;
; reset mode
;

rm:	
	mov	dx,0101h
	jmp	short sm1
	
;
; set mode
;
sm:	
	xor	dx,dx	
sm1:
	xor	cx,cx
	xchg	esc_para_ptr,cl
	call	get_pointer
	inc	cx
sma:	
	mov	al,[bx]
	cmp	al,7
	je	sm_7
	cmp	al,6
	jnz	smb
	mov	set_origin,dh
	jmp	smb
sm_7:
	mov	set_mode_data,dl
smb:
	inc	bx
	loop	sma
	jmp	st12

;
; keyboad key reassignment
;

rak:	xor	dx,dx
	xchg	esc_para_ptr,dl
	call	get_pointer
	mov	ax,[bx]
	call	chk_str_buf
	jnz	rak1
	mov	di,bx
	mov	si,bx
	add	si,cx
	sub	str_buf_offset,cx
	mov	cx,offset str1
	sub	cx,si
	push	es
	push	cs
	pop	es
	cld
repz	movsb
	pop	es
rak1:	call	get_pointer
	or	dl,dl
	jz	rak2
	inc	dx
	inc	dx
	mov	[bx-1],dl
	add	str_buf_offset,dx
	add	bx,dx
rak2:	mov	byte ptr [bx-1],0
	mov	word ptr state,offset st1
	ret


str_buf	label	byte
	db	4,0,72h,10h
	db	196 dup (0)
str1	db	0

;
	

code	ends
	end	start


