	TITLE	RS-232 I/O functions
	SUBTTL	Copyright 1985 by Epson America , Inc.
	NAME	RS-232 I/O

;**
MSDOS	EQU 	2
;**

DSEG	MACRO	
DGROUP	GROUP	DATA
DATA	SEGMENT	WORD PUBLIC 'DATA'
	ASSUME	DS:DGROUP
	ENDM

ENDDS	MACRO
DATA	ENDS
	ENDM

PSEG	MACRO
PGROUP	GROUP	PROG
PROG	SEGMENT	BYTE PUBLIC 'PROG'
	ASSUME	CS:PGROUP
	ENDM

ENDPS	MACRO
PROG	ENDS
	ENDM
	ENDIF

	PSEG
;**
;
; name		init232 -- initializes RS-232 port 
;
; synopsis	c = inp(port,baud,length,stop,parity);
;	int c;returned error information
;	int port;	com port  1 or 2 - default COM2:
;	int baud ; baud rate - 1200(12) or  9600(96) - default 9600
;	int parity ; even(E), odd(O) or none(N) - default none
;	int length ; 	7 or 8 bits - default 8
;	int stop ; 1 or 2 - default 1
;
; description	This function initializes the RS-232 port
;
;**
	PUBLIC	INP
	PUBLIC PORT
;
; 8250 UART ADDRESSES AND REGISTER OFFSETS
;
COM1_ADRS	EQU	0348H
COM2_ADRS	EQU	0248H
RCV_REG		EQU	0	;RECEIVE REGISTER
XMIT_REG		EQU	0	;TRANSMIT REGISTER
DLL_REG		EQU	0	;DIVISOR LOW BYTE REGISTER
DLH_REG		EQU	1	;DIVISOR HI  BYTE REGISTER
IER_REG		EQU	1	;INTERRUPT ENABLE REGISTER
IIR_REG		EQU	2	;INTERRUPT IDENTIFICATION REGISTER
LCR_REG		EQU	3	;LINE CONTROL REGISTER
MCR_REG		EQU	4	;MODEM CONTROL REGISTER
LSR_REG		EQU	5	;LINE STATUS REGISTER
MSR_REG		EQU	6	;MODEM STATUS REGISTER

COM_BASE_ADRS	DW	COM2_ADRS	;DEFAULT RS-232 BASE ADDRESS

INP	PROC	NEAR
	PUSH	BP		;SAVE BP
	MOV	BP,SP
	MOV	AX,[BP+4]	; GET COM: PORT NUMBER
	CMP 	AL,01		
	JNZ	SKIP1		; IF IT IS NOT COM1: THEN DEFAULT COM2:
	MOV	[COM_BASE_ADRS],COM1_ADRS
	
;SET DEFAULT PARITY,LENGTH,STOP BITS AND TURN ON DIVISOR LATCH
;ACCESS BIT (DLAB) TO SET BAUD RATE
	MOV	DX,[COM_BASE_ADRS]
	ADD	DX,BYTE PTR LCR_REG
	MOV	AL,10000011B
	OUT	DX,AL
SKIP1:
	MOV	DX,[COM_BASE_ADRS]
	ADD	DX,BYTE PTR DLH_REG
	XOR	AL,AL	
	MOV	
	MOV	AX,[BP+6]	;GET BAUD RATE ARGUMENT
	CMP	AL,12D		
	JZ	SET_1200
;ELSE SET 9600 BAUD
	
	IN	AL,DX		;GET INPUT BYTE
	XOR	AH,AH		;CLEAR HIGH BYTE
	POP	BP
	RET
INP	ENDP
	PAGE
;**
;
; name		outp -- output byte to port
;
; synopsis	outp(port,c);
;		int port;	port address
;		int c;		byte to send
;
; description	This function sends the specified character to
;		the specified port.
;
;**
	PUBLIC	OUTP
	IF	LPROG
OUTP	PROC	FAR
	ELSE
OUTP	PROC	NEAR
	ENDIF
	PUSH	BP		;SAVE BP
	MOV	BP,SP
	MOV	DX,[BP+X]	;GET PORT ADDRESS
	MOV	AX,[BP+X+2]	;GET OUTPUT BYTE
	OUT	DX,AL
	POP	BP
	RET
OUTP	ENDP
	ENDPS	
	END

