page 60,132

        TITLE   FORMATTING FOR DISKCOPY

;---------------------------------------------------------------:
;Date		01/02/85                                        :
;Synopsis                                                       :
;	Created by Vuong Tran		                        :
;								:
;Date		01/04/85					:
;Synopsis							:
;	Forbids hard disk formatting				:
;								:
;Date		01/16/85					:
;Synopsis							:
;	Add <num_of_sides>, <num_of_tracks>, <num_of_sides>	:
;---------------------------------------------------------------:

CODE    SEGMENT PUBLIC BYTE
	PUBLIC	BOOT_SECTOR
	EXTRN	DEST:BYTE				;in module diskcopy.asm
	EXTRN	NUM_OF_SECTORS:BYTE			;In module diskmes.asm
	EXTRN	NUM_OF_SIDES:BYTE, NUM_OF_TRACKS:BYTE   ;

BADSIZ		DW	2 DUP (?)
DBLFLG		DB	?
CLEARFLG	DB	?
CLUSSIZ		DW	?
SECSIZ 		DW	?
FDSKSIZ		DD	?
ROOTSTR		DB	?
		DB	":"
ALLFILE		DB	-1,0,0,0,0,0,0FFH
ALLDRV		DB	0,"???????????"
		DB	26 DUP (?)
CLEANFILE	DB	0
CLNNAM		DB	"AAAFFFFFFOR"
		DB	26 DUP (?)

MAX_TRACKS	DB	?	;maximum number of tracks/side
numsec		db	?	;number of sectors/track
fatsec		db	?	;number of sectors used for FAT area
FATID		DB	?
STARTSECTOR	DW	?	;THE 1ST DATA SECTOR NUMBER
SECTORS		DW	?
track		db	?
side		db	?
retry		db	?
multsec		db	?
drive		db	?	;target drive
switchmap	db	?
 ;_______________________________________
	;    |	  |    |    |    |    |    |    |
	;    |  | H  |  1 | 8  |    |    |    |
	;____|____|____|____|____|____|____|____|

		; H = 1	- quad-density
		; H = 0 - double-density
		; 1 = 1 - single-sided
		; 1 = 0 - double-sided
		; 8 = 1 - 8 sectors/track
		; 8 = 0 - 9 sectors/track


form_dat	db	?,?,1,2		;track #, head #, sector #, bytes/sector code
		db	?,?,2,2
		db	?,?,3,2
		db	?,?,4,2
		db	?,?,5,2
		db	?,?,6,2
		db	?,?,7,2
		db	?,?,8,2
		db	?,?,9,2

BOOT_SECTOR	DB	512 DUP (?)

FRMTERR		DB	"Format failure. Retry $"
NOUSE		DB	"Track 0 bad - disk unusable",cr,lf,"$"
INVDRV		DB	"Invalid drive specification$"
CRLFMSG		DB	CR,LF,"$"
time_out_msg	db	cr,lf,"Drive is not ready or drive is a hard disk",cr,lf,"$"
wrt_pro_msg	db	"Attempt write-protect violation",cr,lf,"$"
tk0_msg		db	"Track 0 is bad",cr,lf,"$"
END_MSG		DB	"Format complete",cr,lf,"$"

FATSPACE	DW	FATBUF
FATBUF		DB	6 * 512 DUP (?)
CODE    ENDS


CONST   SEGMENT PUBLIC BYTE
DISK_RESET	EQU	0DH
CHDIR		EQU	3BH
FCB_DELETE 	EQU	13H
FCB_CREATE	EQU	16H
GET_DPB		EQU	32H
STD_CON_STRING_OUTPUT	EQU	09H
SW_H18		EQU	00111000B
SW_H		EQU	00100000B	;bit position for switch h (80 tracks)
sw_1		equ	00010000b	;bit position for switch 1
sw_8		equ	00001000b	;bit position for switch 8
SW_H8		EQU	00101000B
SW_81		EQU	00011000B
dos		equ	21h		;dos call
dos_pr_str	equ	09h		;dos print string command
rom_disk_io	equ	13h
rom_format	equ	05h		;rom disk format command
rom_write	equ	03h		;rom disk write command
rom_read	equ	02h		;rom disk read command
rom_verify	equ	04h		;rom disk verify command
rom_reset	equ	00h		;rom disk reset command
wrp_err		equ	03h		;rom disk write protect error
timeo_err	equ	80h		;rom disk motor time out error
CR	 	EQU	13
LF		EQU	10
GET_DEFAULT_DRIVE	EQU	19H

CONST   ENDS

DATA    SEGMENT PUBLIC BYTE
DATA    ENDS

DG      GROUP   CODE,CONST,DATA

CODE    SEGMENT PUBLIC BYTE
        ASSUME  cs:DG,ds:DG,es:DG,ss:DG

        PUBLIC  FORMAT_DISK, DISKINFO, RD_SEC, FIX_FDPB
	EXTRN	PROMPTYN:NEAR	;in module <diskmes.asm>


FORMAT_DISK	PROC	NEAR

SYSLOOP:
        MOV     WORD PTR BADSIZ,0       ;Must intialize for each iteration
        MOV     WORD PTR BADSIZ+2,0
        MOV     BYTE PTR DBLFLG,0
        MOV     BYTE PTR CLEARFLG,0
        MOV     AL,DRIVE                ;Fetch drive
        ADD     AL,"A"                  ;(AL)= ASCII designation
        CALL    DISKFORMAT              ;Format track 0
        JNC     GETTRK
FRMTPROB:
        MOV     DX,OFFSET FRMTERR
	CALL	PROMPTYN
	JZ	SYSLOOP
	INT	20H			;back to DOS

        ;Mark any bad sectors in the FATs
        ;And keep track of how many bytes there are in bad sectors

GETTRK:
        CALL    BADSECTOR               ;format remaining tracks
        JC      FRMTPROB                ;Had an error in Formatting - can't recover
        CMP     AX,0                    ;Are we finished?
        JNZ     TRKFND                  ;No - check error conditions
        JMP     DRTFAT                  ;Yes
TRKFND:
        CMP     BX,STARTSECTOR          ;Are any sectors in the system area bad?
        JGE     CLRTEST
        MOV     DX,OFFSET NOUSE         ;Can't build FATs of Directory
        CALL    PRINT
        JMP     FRMTPROB                ;Bad disk -- try again
CLRTEST:
        MOV     SECTORS,AX              ;Save the number of sectors on the track
        CMP     BYTE PTR CLEARFLG,0     ;Have we already cleared the FAT and DIR?
        JNZ     SYSTEST                 ;Yes - all set
        INC     CLEARFLG                ;Set the flag
        PUSH    BX
        CALL    CLEAR                   ;Fix-up fat and directory
        POP     BX
SYSTEST:

BAD100:
; BX is the first bad sector #, SECTORS is the number of bad sectors starting
; at BX. This needs to be converted to clusters. The start sector number may
; need to be rounded down to a cluster boundry, the end sector may need to be
; rounded up to a cluster boundry. Know BX >= STARTSECTOR
        SUB     BX,STARTSECTOR          ; BX is now DATA area relative
        MOV     CX,BX
        ADD     CX,SECTORS
        DEC     CX                      ; CX is now the last bad sector #
        MOV     AX,BX
        XOR     DX,DX
        DIV     CLUSSIZ
        MOV     BX,AX                   ; BX is rounded down and converted
                                        ; to a cluster #. Where cluster 0 =
                                        ; first cluster of data. First bad
                                        ; Sector is in cluster BX.
        MOV     AX,CX
        XOR     DX,DX
        DIV     CLUSSIZ
        MOV     CX,AX                   ; CX is rounded up and converted to a
                                        ; to a cluster #. Where cluster 0 =
                                        ; first cluster of data. Last bad
                                        ; Sector is in cluster CX.
        SUB     CX,BX
        INC     CX                      ; CX is number of clusters to mark bad
        ADD     BX,2                    ; Bias start by correct amount since
                                        ; first cluster of data is really
                                        ; cluster 2.
        MOV     AX,CLUSSIZ              ; Sectors/Cluster
        MUL     SECSIZ                  ; Times Bytes/Sector
        MOV     BP,AX                   ; = Bytes/Cluster

; Mark CX clusters bad starting at cluster BX
PACKIT:
        MOV     DX,0FF7H                ;0FF7H indicates a bad sector
        CALL    PACK                    ;Put it in the allocation map
        CMP     DX,DI                   ;Have we already marked it bad?
        JZ      BAD150                  ;if so, don't add it in
        ADD     WORD PTR BADSIZ,BP      ;Add in number of bad bytes
        JNB     BAD150
        INC     WORD PTR BADSIZ+2
BAD150:
        INC     BX                      ;Next cluster
        LOOP    PACKIT                  ;Continue for # of clusters
        JMP     GETTRK
DRTFAT:
        CMP     BYTE PTR CLEARFLG,0
        JNZ     CLEARED
        CALL    CLEAR                   ;Clear the FAT and Dir
CLEARED:
        CALL    WRTFAT
        JNC     FATWRT
        MOV     DX,OFFSET NOUSE
        CALL    PRINT
        JMP     FRMTPROB

FATWRT:

STATUS:
;       CALL    CRLF			;VQT
        MOV     AH,DISK_RESET
        INT     21H
        CALL    DONE                    ;Final call to OEM module
        JNC     REPORTC
        JMP     FRMTPROB                ;Report an error

REPORTC:

	RET
FORMAT_DISK	ENDP


; Inputs:
        ;BX = Cluster number
        ;DX = Data
; Outputs:
        ;The data is stored in the FAT at the given cluster.
        ;SI is destroyed
        ;DI contains the former contents
        ;No other registers affected

PACK	PROC
        PUSH    BX
        PUSH    CX
        PUSH    DX
        MOV     SI,BX
        SHR     BX,1
        ADD     BX,FATSPACE
        ADD     BX,SI
        SHR     SI,1
        MOV     SI,WORD PTR [BX]
        MOV     DI,SI
        JNB     ALIGNED
        MOV     CL,4
        SHL     DX,CL
        SHR     DI,CL
        AND     SI,15
        JMP     SHORT PACKIN

ALIGNED:
        AND     SI,0F000H
PACKIN:
        AND     DI,00FFFH               ;DI CONTAINS FORMER CONTENTS
        OR      SI,DX
        MOV     WORD PTR[BX],SI
        POP     DX
        POP     CX
        POP     BX
        RET
PACK	ENDP


CLEAR	PROC
        ;Clear the FAT and directory and set Dirty byte in the FAT
        MOV     AL,FATID
        OR      AL,0F8H                 ;Make sure it's a legal value
        MOV     AH,0FFH
        MOV     DI,FATSPACE
        MOV     WORD PTR[DI],AX
        MOV     BYTE PTR[DI+2],AH
        MOV     AH,DISK_RESET
        INT     21H
        CALL    WRTFAT


        CALL    FDPB
        MOV     WORD PTR FDSKSIZ,DX
        MOV     SECSIZ,CX
        MOV     AH,0
        MOV     CLUSSIZ,AX
        SHR     DX,1
        JNC     ROUNDED
        INC     DX
ROUNDED:
        ADD     DX,WORD PTR FDSKSIZ
        XOR     AX,AX
        MOV     CX,DX
        MOV     DI,FATSPACE
        ADD     DI,3
        REP     STOSB
        MOV     AH,DISK_RESET
        INT     21H
        CALL    WRTFAT
        MOV     DL,[DRIVE]
        ADD     DL,'A'
        MOV     [ROOTSTR],DL
        MOV     DX,OFFSET ROOTSTR
        MOV     AH,CHDIR
        INT     21H                     ;Go to root on target drive
        MOV     AL,DRIVE
        INC     AL
        MOV     ALLDRV,AL
        MOV     AH,FCB_DELETE
        MOV     DX,OFFSET ALLFILE
        INT     21H
	JMP	RET25

;       TEST    SWITCHMAP,OLDSW         ;See if E5 terminated DIR requested
;       JZ      RET25
;       MOV     AL,DRIVE
;       INC     AL
;       MOV     BYTE PTR CLEANFILE,AL              ;Get the drive
;       MOV     DX,OFFSET CLEANFILE
;       MOV     AH,FCB_CREATE
;MAKE_NEXT:
;        INT     21H
;        OR      AL,AL
;        JNZ     DELETE_THEM
;        INC     BYTE PTR CLNNAM
;       CMP     BYTE PTR CLNNAM,"Z" + 1
;        JNZ     MAKE_NEXT
;        MOV     BYTE PTR CLNNAM,"A"
;        INC     BYTE PTR CLNNAM + 1
;        CMP     BYTE PTR CLNNAM + 1,"Z" + 1
;        JNZ     MAKE_NEXT
;        MOV     BYTE PTR CLNNAM + 1,"A"
;        INC     BYTE PTR CLNNAM + 2
;        JMP     MAKE_NEXT

;DELETE_THEM:
;        MOV     WORD PTR CLNNAM,"??"
;        MOV     BYTE PTR CLNNAM + 2,"?"
;        MOV     AH,FCB_DELETE
;        INT     21H
RET25:
        RET                             ;And return
CLEAR	ENDP


FDPB	PROC
	MOV     DL,DRIVE
        INC     DL
        MOV     AH,GET_DPB
	PUSH	ES
        PUSH    DS                ;DS =CODE
        INT     21H
        INC     AL
        JZ      DRVERR
;** -------------------------------- VQT
	CALL	FIX_FDPB
        MOV     ES:WORD PTR [BX+13],DX
        INC     ES:WORD PTR [BX+13]
        MOV     ES:BYTE PTR [BX+4],AL
        DEC     ES:BYTE PTR [BX+4]
        MOV     ES:WORD PTR [BX+2],CX
;** --------------------------------
        POP     DS                ;RESTORE DS=CODE
	POP	ES
        RET
DRVERR:
        POP     DS
	POP	ES
        MOV     DX,OFFSET INVDRV
;       JMP     PERROR
	CALL	PRINT
	INT	20H
FDPB	ENDP



FIX_FDPB	PROC
		PUSH	DS
		POP	ES		;ES:BX --> DPB BLOCK
		PUSH	CS		;DS =CODE
		POP	DS              ;
	ASSUME DS:CODE
		MOV	[SECSIZ], 512		;512 bytes/sector
		MOV	WORD PTR ES:[BX+6], 01H
		MOV	BYTE PTR ES:[BX+8], 02H	;

		TEST	BYTE PTR SWITCHMAP, SW_H
		JZ	MODE40
		JMP	MODE80
MODE40:		TEST	BYTE PTR SWITCHMAP, SW_8
		JNZ 	SET_8
		TEST	BYTE PTR SWITCHMAP, SW_1
		JNZ	SET_91
SET_9:		MOV	[CLUSSIZ], 2		;#sectors/cluster
		MOV	WORD PTR [FDSKSIZ], 354	;# data clusters
		MOV	BYTE PTR ES:[BX+5], 01H
		MOV	WORD PTR ES:[BX+9], 70H
		MOV	WORD PTR ES:[BX+0BH], 12
		MOV	BYTE PTR ES:[BX+0FH], 2
		MOV	WORD PTR ES:[BX+10H], 5
		MOV	AL, [FATID]
		MOV	BYTE PTR ES:[BX+16H], AL
		JMP	FIX_EXIT

SET_91: 	MOV	[CLUSSIZ], 1
		MOV	WORD PTR [FDSKSIZ], 351
		MOV	BYTE PTR ES:[BX+5], 0H
		MOV	WORD PTR ES:[BX+9], 40H
		MOV	WORD PTR ES:[BX+0BH], 9
		MOV	BYTE PTR ES:[BX+0FH], 2
		MOV	WORD PTR ES:[BX+10H], 5
		MOV	AL, [FATID]
		MOV	BYTE PTR ES:[BX+16H], AL
		JMP	FIX_EXIT

SET_8:		TEST	BYTE PTR SWITCHMAP, SW_1
		JNZ	SET_81
		MOV	[CLUSSIZ], 2
		MOV	WORD PTR [FDSKSIZ], 315
		MOV	BYTE PTR ES:[BX+5], 01H
		MOV	WORD PTR ES:[BX+9], 70H
		MOV	WORD PTR ES:[BX+0BH], 10
		MOV	BYTE PTR ES:[BX+0FH], 1
		MOV	WORD PTR ES:[BX+10H], 3
		MOV	AL, [FATID]
		MOV	BYTE PTR ES:[BX+16H], AL
		JMP	FIX_EXIT

SET_81:		MOV	[CLUSSIZ], 01
		MOV	WORD PTR [FDSKSIZ], 313
		MOV	BYTE PTR ES:[BX+5], 0H
		MOV	WORD PTR ES:[BX+9], 40H
		MOV	WORD PTR ES:[BX+0BH], 7
		MOV	BYTE PTR ES:[BX+0FH], 1
		MOV	WORD PTR ES:[BX+10H], 3
		MOV	AL, [FATID]
		MOV	BYTE PTR ES:[BX+16H], AL
		JMP	FIX_EXIT

MODE80:		TEST	BYTE PTR SWITCHMAP, SW_8
		JNZ	SET_H8
SET_H9:		MOV	[CLUSSIZ], 02
		MOV	WORD PTR [FDSKSIZ], 713
		MOV	BYTE PTR ES:[BX+5], 01H
		MOV	WORD PTR ES:[BX+9], 70H
		MOV	WORD PTR ES:[BX+0BH], 14
		MOV	BYTE PTR ES:[BX+0FH], 3
		MOV	WORD PTR ES:[BX+10H], 7
		MOV	AL, [FATID]
		MOV	BYTE PTR ES:[BX+16H], AL
		JMP	FIX_EXIT

SET_H8:		TEST	BYTE PTR SWITCHMAP, SW_1
		JNZ	SET_H81
		MOV	[CLUSSIZ], 02
		MOV	WORD PTR [FDSKSIZ], 634
		MOV	BYTE PTR ES:[BX+5], 01H
		MOV	WORD PTR ES:[BX+9], 70H
		MOV	WORD PTR ES:[BX+0BH], 12
		MOV	BYTE PTR ES:[BX+0FH], 2
		MOV	WORD PTR ES:[BX+10H], 5
		MOV	AL, [FATID]
		MOV	BYTE PTR ES:[BX+16H], AL
		JMP	FIX_EXIT

SET_H81:	MOV	[CLUSSIZ], 02          	;WAS 1
		MOV	WORD PTR [FDSKSIZ], 315 ;WAS 630
		MOV	BYTE PTR ES:[BX+5], 1	;WAS 0
		MOV	WORD PTR ES:[BX+9], 70H
		MOV	WORD PTR ES:[BX+0BH], 10
		MOV	BYTE PTR ES:[BX+0FH], 1
		MOV	WORD PTR ES:[BX+10H], 3
		MOV	AL, [FATID]
		MOV	BYTE PTR ES:[BX+16H], AL

FIX_EXIT:	MOV	DX, WORD PTR [FDSKSIZ]
		MOV	AX, [CLUSSIZ]
		MOV	CX, [SECSIZ]
		RET
FIX_FDPB	ENDP

PRINT	PROC
	MOV     AH,STD_CON_STRING_OUTPUT             ;Print msg pointed to by DX
        INT     21H
        RET
PRINT	ENDP

CRLF	PROC
        MOV     DX,OFFSET CRLFMSG
        CALL    PRINT
        RET
CRLF	ENDP

DISKFORMAT	proc	near
; diskformat will format track 0 of target drive (both sides if not /1)

; entry: <SWITCHMAP>
; exit: return error with cbit set if format error or disk write error
;	clear cbit if no error


form_tk0:	;format track 0

	mov	ah,0			;reset drive
	int	rom_disk_io

	mov	track,0			;track = 0
	mov	side,0			;side = 0
	call	form_ver		;format and verify the track
	jc	tk0_err			;if error, goto print message
	test	byte ptr SWITCHMAP,sw_1	;see if /1 is selected
	jnz	tranboot		;yes, then skip format track 0 side 1
	mov	side,1			;side = 1
	call	form_ver		;format and verify the track
	jnc	tranboot		;if no error, then quit
tk0_err:				;print track 0 error and return
	lea	dx,tk0_msg
	call	pr_str			;print error message
tranboot:
	ret
DISKFORMAT	endp


BADSECTOR	proc	near
; badsector will format the target disk from track 1 to 39 if mode 40
;Else, it will format from track 1 to 79 for mode 80
; badsector will report badsector number to format

; entry: <max_tracks>, <numsec>, <switchmap>
; exit: cbit set if hard error (hard error will cause format to abort)
;	cbit cleared if soft error (soft error means reporting of badsector,
;				    format will renter BADSECTOR afterwards)
;	To report badsectors:
;		bx contains the badsector sector number 
;		ax contains the number of consecutive badsectors
;	For final return to format:
;		ax = 0 ; bx = don't care ; cbit = cleared

	push	cs
	pop	es

;check for rentry

	cmp	track,0			;if track=0 then first entry to this routine
	jnz	rentry			;if not first time, skip to rentry
	
	mov	ah,rom_reset		;else, reset drive
	int	rom_disk_io

	mov	track,01		;make track = 1 to indicate rentry for next time
	mov	side,0			;make side 0 flag 0 to indicate side 0 is formatted
	 
rentry:		;while track < 40 , format tracks

	cmp	side,0			;see if side 0 of last entry is formatted
	jnz	form_side0		;if not, format it this time

	push	ax
	mov	al, track
	cmp	al, max_tracks		;if track >= <max_tracks>
 pop	ax
	jae	alldone			;then all done

	;determine format 1 side or 2 sides

	test	byte ptr SWITCHMAP,sw_1	;look at bit 4 (/1)
	jnz	form_side0		;if set, format side 0 only

form_side1:	;format and verify track on side 1

	mov	side,1			;side = 1
	call	form_ver		;format and verify the track

	jc	report			;if format error, report it

form_side0:	;format and verify track on side 0

	mov	side,0			;side = 0
	call	form_ver		;format and verify the track

	inc	track			;increament current track number

	jnc	rentry			;if no error, format next track

	;if format or verify error, report badsector number in bx
	;and consecutive badsectors in ax
report:					
	mov	al,track		;al = track number
	test	byte ptr SWITCHMAP,sw_1	;is /1 selected
	jnz	rp1			;yes, then skip multiply

	add	al,al			;al = al * 2 (al = track * 2)
rp1:	cmp	side,0			;is it from side 1 or side 0
	jz	rp2			;from side 0, skip increament

	inc	al			;al = al + 1 (al = track * 2 + 1)
rp2:	mul	numsec			;ax = al * numsec
	mov	bx,ax			;bx has the value
	mov	al,numsec		;ax = number of consecutive badsector
	cbw				;clear ah
	clc
	ret

alldone:	;final return to format, ax = 0 for indication

	xor	ax,ax
	clc
	ret
BADSECTOR	endp


WRTFAT	proc	near
; write fat space out to the target drive track 0

; entry: <FATSPACE>, <FATSEC>, <DRIVE>
; exit: cbit set if error in write
;	cbit cleared if no error

	push	cs
	pop	es

	MOV	BX, WORD PTR FATSPACE	;es:bx points to memory
	MOV	SI, BX			;build 2nd FAT in memory
	MOV	AL, BYTE PTR FATSEC     ;
	CBW				;
	MOV	DI, AX			;
	MOV	CL, 08			;
	SHL	DI, CL			;
	MOV	CX, DI			;
	ADD	DI, SI                  ;
REP	MOVSB                           ;

	mov	al,fatsec		;al = multiple sector count = fatsec
	mov	cl,2			;fat starts from sector 2
	mov	ch,0			;track 0
	mov	dl,DRIVE		;target drive
	mov	dh,0			;side 0

	call	wr_sec			;write the fat sectors

	ret
WRTFAT	endp

DONE	proc	near
;do nothing and return

	MOV	DX, OFFSET END_MSG
	CALL	PR_STR
	clc
	ret
DONE	endp

form_ver	proc	near
;format and verify the specified track 

;entry: track = the track to format and verify
;	side = the side of the track (0 or 1)
;exit:	cbit set if any error
;	cbit cleared if no error

	mov	ah,track		;ah = current track for format data
	mov	al,side			;al = side to format = 1 for format data
	call	init_form_dat		;initialize format data

	call	form_trk		;format the track

	jc	ret_fv			;if format error, ret

	call	ver_trk			;verify the track
					;ret despite of error or not
ret_fv:	ret
form_ver	endp

init_form_dat	proc	near
; initialize format data for use in rom format

; entry: ah = track number , al = side number
; exit: none

	lea	bx,form_dat		;es:bx points to format data
	mov	cx,09			;init 9 blocks for 9 sectors

init_next:
	mov	byte ptr [bx],ah	;track information
	mov	byte ptr [bx+1],al	;side information
	add	bx,0004h		;point to next block
	loop	init_next

	ret
init_form_dat	endp

form_trk	proc	near
; format track with retries and error handling

; entry: set the side to format in DH
;	 format data initialized
;	 <SWITCHMAP>, <NUMSEC>
;
; exit: cbit set if error
;	cbit cleared if no error

;set format informations for the rom

	lea	bx,form_dat		;es:bx points to format data
	mov	dh,side			;dh = side to format
	mov	dl,DRIVE		;dl = target drive
	TEST	BYTE PTR SWITCHMAP, SW_H	;80 TRACKS MODE?
	JZ	FORM_MODE40			;go if 40 tracks mode
	OR	DL, 40H				;set 80 tracks mode
FORM_MODE40:
	mov	ch,track		;ch = track to format
	mov	cl,01			;cl = sector number = 1
	mov	retry,4			;retry count = 4

;call rom to format the track

form_next:
	mov	al,numsec		;al = sector/track
	mov	ah,rom_format
	int	rom_disk_io
	jnc	form_ret		;if no format error, good return

form_err:
	test	ah,timeo_err or wrp_err	;check if timeout or wrt protect err
	jz	form_reset
	jmp	err_proc		;yes then print error msg

form_reset:
	mov	ah,0			;no, then reset drive and retry
	int	rom_disk_io

	dec	retry			;dec retry count
	jnz	form_next		;retry if retry count not 0

	stc
form_ret:
	ret
form_trk	endp


ver_trk	proc	near
; verify track with retries and error handling

; entry: set the side to verify in DH
;	 <SWITCHMAP>, <NUMSEC>
; exit: cbit set if error

;set verify informations for the rom

	mov	dh,side			;dh = side to format
	mov	dl,DRIVE		;dl = target drive
	TEST	BYTE PTR SWITCHMAP, SW_H;80 tracks mode?
	JZ	VER_MODE40              ;go if 40 tracks mode
	OR	DL, 40H			;set 80 tracks mode
VER_MODE40:
	mov	ch,track		;ch = track to format
	mov	cl,01			;cl = sector number = 1
	mov	retry,3			;only 3 retries

;call rom to verify track

ver_next:
	mov	al,numsec		;al = sector/track
	mov	ah,rom_verify
	int	rom_disk_io
	jc	ver_err			;if verify error

	ret				;good return

ver_err:
	test	ah,timeo_err or wrp_err ;check if timeout or wrt protect err
	jnz	err_proc		;if yes, print error msg

	mov	ah,0			;reset drive
	int	rom_disk_io

	dec	retry			;dec retry count
	jnz	ver_next		;retry if retry count not 0

	stc				;error return
	ret
ver_trk	endp

wr_sec	proc	near
; write sectors to the disk with retries and error handling

; entry: es:bx points to the memory buffer
;	 al = number of sectors to write
;	 ch = track to write on
;	 cl = sector to write on
;	 dh = side to write on
;	 dl = drive to write to
; exit:	cbit set if write error

	TEST	BYTE PTR SWITCHMAP, SW_H	;80 TRACKS MODE?
	JZ	WR_MODE40			;GO IF 40 TRACKS MODE
	OR	DL, 40H				;SET 80 TRACKS MODE
WR_MODE40:
	mov	retry,4			;retry = 4
	mov	multsec,al		;save number of sector to write
wr_next:
	mov	al,multsec
	mov	ah,rom_write		;call rom to write
	int	rom_disk_io
	jc	wr_err			;if write error

	ret				;good return

wr_err:
	test	ah,timeo_err or wrp_err	;check if timeout or wrt protect err
	jz	wr_retry		;no, then retry

	call	err_proc		;yes then print err msg (no return here)

wr_retry:
	mov	ah,0			;else reset drive
	int	rom_disk_io

	dec	retry			;dec retry count
	jnz	wr_next			;if retry not zero

	stc				;else bad return
	ret
wr_sec	endp

rd_sec	proc	near
; read sectors from the disk with retries and error handling

; entry: es:bx points to the memory buffer
;	 al = number of sectors to read
;	 ch = track to read from
;	 cl = sector to read from
;	 dh = side to read from
;	 dl = drive to read from
; exit:	cbit set if read error

	mov	retry,4			;retry = 4
	mov	multsec,al		;save number of sector to read
rd_next:
	mov	al,multsec
	mov	ah,rom_read		;call rom to read
	int	rom_disk_io
	jc	rd_retry		;if read error

	ret				;good return

rd_retry:
	mov	ah,0			;else reset drive
	int	rom_disk_io

	dec	retry			;dec retry count
	jnz	rd_next			;if retry not zero

	stc				;else bad return
	ret
rd_sec	endp

err_proc	proc	near
; err_proc will print out the approiate error message and return with cbit set
; err_proc is a black hole , it will not return to the caller but instead to 
; the caller's caller's caller.

;entry: ah = disk error condition 
;exit: cbit set

	test	ah,80h			;timeout error?
	jz	ep1			;no, then check next

	lea	dx,time_out_msg
	call	pr_str			;print error message
	jmp	short ep2

ep1:	test	ah,03h			;write protect violation?
	jz	ep2			;no, then check next

	lea	dx,wrt_pro_msg
	call	pr_str			;print error message

;	jmp	ep2

ep2:	;no more for now

	pop	ax			;trash caller's return addr
	pop	ax			;trash caller's caller's return addr
	stc
	ret				;error return to FORMAT
err_proc	endp

pr_str	proc	near
; call dos to print the string, set carry and return

; entry: dx has the effective address of the string
; exit: cbit always set

	mov	ah,dos_pr_str
	int	dos

	stc
	ret
pr_str	endp


DISKINFO	PROC	NEAR
;
;Report relevant disk information
;Entry	: (BL) = media byte (or fatid)
;	  <DEST> =target drive
;Exit	: <SWITCHMAP>, <FATID>, <FATSEC>, <STARTSECTOR>
;	  <NUMSEC>, <MAX_TRACKS>, <DRIVE>, <NUM_OF_SECTORS>
;	  <NUM_OF_SIDES>, <NUM_OF_TRACKS> if valid fatid (carry clear)
;	  Carry set if invalid fatid
;
	MOV	MAX_TRACKS, 80
	MOV	NUM_OF_TRACKS, '8'	;update message
	MOV	NUM_OF_SIDES, '2'	;
	MOV NUM_OF_SECTORS, '9'	;
	CMP	BL, 0F9H	;quad-density, 9 sec/trk, double sided (DS)
	JZ	FORM_H9
	CMP	BL, 0FBH	;Quad-density, 8 sec/trk, DS
	JZ	FORM_H8
	CMP	BL, 0FAH	;Quad-density, 8 sec/trk, SS
	JZ	FORM_H81
	MOV	MAX_TRACKS, 40
	MOV	NUM_OF_TRACKS, '4'
	CMP	BL, 0FDH	;Double density (DD), 9 sec/trk, DS
	JNZ	F0
	JMP	FORM9
F0:	CMP	BL, 0FCH	;DD, 9 SEC/TRK, SS
	JNZ	F1
	JMP	FORM91
F1:	CMP	BL, 0FFH	;DD, 8 SEC/TRK, DS
	JNZ	F2
	JMP	FORM8
F2:	CMP	BL, 0FEH	;DD, 8 SEC/TRK, SS
	JNZ	F3
	JMP	FORM81
F3:	STC			;INVALID MEDIA
	RET
FORM_H9:
	MOV	BYTE PTR [SWITCHMAP], SW_H
	MOV	[FATSEC], 6	;FAT sectors
	MOV	[NUMSEC], 9	;sectors/track
	MOV	[FATID], 0F9H	;fatid
	MOV	[STARTSECTOR], 15	;1ST DATA sector
	JMP	VALID_MEDIA

FORM_H8:
	MOV	BYTE PTR [SWITCHMAP], SW_H8
	MOV	[FATSEC], 4	;FAT sectors
	MOV	[NUMSEC], 8	;sectors/track
	MOV 	NUM_OF_SECTORS, '8'
	MOV	[FATID], 0FBH	;fatid
	MOV	[STARTSECTOR], 13	;1ST DATA sector
	JMP	VALID_MEDIA

FORM_H81:
	MOV	BYTE PTR [SWITCHMAP], SW_H18
	MOV	[FATSEC], 2	;FAT sectors
	MOV	[NUMSEC], 8	;sectors/track
	MOV	NUM_OF_SIDES, '1'	;update message
	MOV 	NUM_OF_SECTORS, '8'	;
	MOV	[FATID], 0FAH	;fatid
	MOV	[STARTSECTOR], 11	;1ST DATA sector
	JMP	VALID_MEDIA

FORM9:
	MOV	BYTE PTR [SWITCHMAP], 0
	MOV	[FATSEC], 4	;FAT sectors
	MOV	[NUMSEC], 9	;sectors/track
	MOV	[FATID], 0FDH	;fatid
	MOV	[STARTSECTOR], 13	;1ST DATA sector
	JMP	SHORT VALID_MEDIA

FORM91:
	MOV	BYTE PTR [SWITCHMAP], SW_1
	MOV	[FATSEC], 4	;FAT sectors
	MOV	[NUMSEC], 9	;sectors/track
	MOV	NUM_OF_SIDES, '1'	;update message
	MOV	[FATID], 0FCH	;fatid
	MOV	[STARTSECTOR], 10	;1ST DATA sector
	JMP	SHORT VALID_MEDIA

FORM8:
	MOV	BYTE PTR [SWITCHMAP], SW_8
	MOV	[FATSEC], 2	;FAT sectors
	MOV	[NUMSEC], 8	;sectors/track
	MOV 	NUM_OF_SECTORS, '8'	;
	MOV	[FATID], 0FFH	;fatid
	MOV	[STARTSECTOR], 11	;1ST DATA sector
	JMP	SHORT VALID_MEDIA

FORM81:
	MOV	BYTE PTR [SWITCHMAP], SW_81
	MOV	[FATSEC], 2	;FAT sectors
	MOV	[NUMSEC], 8	;sectors/track
	MOV	NUM_OF_SIDES, '1'	;update message
	MOV 	NUM_OF_SECTORS, '8'	;
	MOV	[FATID], 0FEH	;fatid
	MOV	[STARTSECTOR], 8	;1ST DATA sector

VALID_MEDIA:	PUSH	AX
		MOV	AL, [DEST]	;Set target disk
		MOV	[DRIVE], AL     ;
		POP	AX
		RET
DISKINFO	ENDP

CODE  ENDS
      END
