PAGE 60, 132

		TITLE EPSON MODE UTILITY

;----------------------------------------------------------------
;Date 			01/22/85 	                        :
;Synopsis							:
;	Program modified by Vuong Tran				:
;								:
;	The Mode command sets the mode of operation on a 	:
;	printer or on a display connected to the Color/Graphics :
;	Monitor Adapter, sets options for an Asynchronous Com.	:
;	Adapter, or causes printer output to be routed to an	:
;	Asynchronous Communication Adapter.			:
;	This MODE command is different than IBM MODE command   	:
;	only in the line printer option. A missing or invalid	:
;	parameter under IBM results in no change of mode of	:
;	operation for that parameter. It ends up in default	:
;	settings under "our" MODE command.			:
;								:
;								:
;Format								:
;	Option 1 (For the printer)				:
;	   MODE LPT#:[n][,[m][,P]]				:
; where								:
;	   # is 1, 2, or 3 (the printer number)			:
;	   n is 80 or 132 characters per line (default=80)	:
;          m is 6 or 8 lines/inch vertical spacing (default=6)	:
;	   P specifies continuous retry on time-out errors	:
;	   Missing or invalid parameters will result in default	:
;	   settings.						:
;								:
;	Option 2 (For Asynchronous Communications Adapter)	:
;	   MODE COMn:baud[,parity[,databits[,stopbits[,P]]]]	:
;	where							:
;    	   n        Either 1 or 2				:
;	   baud    110, 150, 300, 600, 1200, 2400, 4800, or 9600:
;		    (Only the first 2 characters are required;	:
;		     subsequent characters are ignored.)	:
;	   parity   Either N (none), O (odd), or E (even) -	:
; 					(default = E)		:
;	   databits Either 7 or 8 (default=7)			:
;	   stopbits Either 1 or 2 (if baud=110, default=2;	:
;				   if baud<>110, default=1)	:
;	   Except for baud rate, missing or invalid parameters	:
;	   will result in default settings.			:
;								:
;	 Option 3 (To redirect parallel printer output to an	:
;	           Asynchronous Communications Adapter)		:
;          MODE LPT#:=COMn					:
;	 where							:
;	    #	Either 1, 2, 3 (printer number)			:
;	    n	Either 1 or 2 (Async Com Adapter number) 	:
;		Notes:						:
;		1.	Before you can use MODE to redirect	:
;			parallel printer output to a serial	:
;			device, you must initialize the 	:
;			Asynchronous Communication Adapter by	:
;			using option 2 (see above). If that	:
;			serial device is a printer, your serial-:
;			ization command should also include the	:
;			P parameter.				:
;								:
;		2.	MODE LPT#:[n][,m] disables the redirect-:
;			ion for the printer designated by the #.:
;								:
;	Option 4 (For switching Display Adapters, and setting 	:
;		  display mode of the Color/Graphics Monitor	:
;		  Adapter)					:
;	   MODE n, or MODE [n],m[,T]				:
;	where							:
;	n is 40, 80, BW40, BW80, MONO, CO40, CO80		:
;	40	sets the display width to 40 chars/line (for	:
;		Color/Graphics Monitor Adapter			:
;	80	sets the display width to 80 chars/line (for	:
;		Color/Graphics Monitor Adapter			:
;	BW40	switches the active display adapter to the	:
;		Color/Graphics Monitor Adapter, and sets the	:
;		display mode to Black and White (disable color)	:
;		with 40 chars/line.				:
;	BW80	switches the active display adapter to the	:
;		Color/Graphics Monitor Adapter, and sets the	:
;		display mode to Black and White (disable color)	:
;		with 80 chars/line.				:
;	CO40	switches the active display adapter to the	:
;		Color/Graphics Monitor Adapter, enables color,	:
;		and sets the display width to 40 chars/line    	:
;	CO80	switches the active display adapter to the	:
;		Color/Graphics Monitor Adapter, enables color,	:
;		and sets the display width to 80 chars/line    	:
;	MONO	switches the active display adapter to the	:
;		Monochrome Display Adapter (always 80 char/line):
;	m	is R or L (shift display right or left)		:
;	T	request a test pattern used to align the display:
;								:
;	For readability, you can shift the display 1 character  :
;	(for 40 columns) or 2 characters (for 80 columns) in	:
;	either direction. If you specify T in the MODE command,	:
;       a prompt asks you if the screen is aligned properly. If	:
;	you enter Y the command ends. If you enter N the shift	:
;	is repeated followed by the same prompt.		:
;	A missing or invalid parameter will result in no change	:
;	of mode of operation for that parameter.
;	 							:
;		Notes:						:
;		Mode 80 is the only working mode on the QX88/	:
;		Apollo native mode. Other modes are useful with	:
;		the IBM emulator card in.			:
;								:
;Development Tools						:
;	IBM Macro Assembler, version 1.00, under PCDOS 2.10	:
;	IBM Linker, version 2.10, under PCDOS 2.10		:
;	IBM debugger, under PCDOS 2.10				:
;								:
;----------------------------------------------------------------


;--------------------------------
;	EQUATES			:
;--------------------------------
PARM_AREA	EQU	80H				;unformated parameter area
SPACE		EQU	20H				;space delimiter
COMMA		EQU	2CH				;comma delimiter
COLON		EQU	3AH
CR		EQU	0DH
LF		EQU	0AH
MIN_SIO_CMD	EQU	07H				;minimum length for a valid
							;command addressing a serial port
MIN_LPT_CMD	EQU	04H				;minimum length for a valid
							;command addressing a printer port

;--------------------------------
;	Data	Declaration	:
;--------------------------------
ABS0		SEGMENT	AT 0H
	ORG	400H
RS232_BASE	DW	4 DUP (?)
PRINTER_BASE	DW	4 DUP (?)

	ORG	410H
EQUIP_FLAG	DW	?				;equipment flag

	ORG	471H
BIOS_BREAK	DB	?				;bit 7 = 1 if break key depressed

	ORG	530H
USER_INT14H	DW	2 DUP (?)       		;pointer to user RS232 routine
SYSTEM_INT14H	DW	2 DUP (?)			;pointer to BIOS RS232 routine
SYSTEM_INT17H	DW	2 DUP (?)       		;pointer to BIOS printer routine
REDIRECTED_TO_SIO	DB	(?)     		;flag set if redirection
							;from serial port to line printer
ABS0		ENDS

;------------------------------
;	Code		      :
;------------------------------

CODE		SEGMENT	PUBLIC	'CODE'
	 ASSUME CS:CODE, DS:CODE, ES:CODE, SS:CODE

		ORG	100H
START:		JMP	SETUP_STACK
VERSION		DB	'REV 1.00 /12/04/84'    	;released version
USER_VIDEO_PARM		DW	32 DUP (?)		;user video parameter table
							;has to be resident

	;------ User RS232 service routine ------
	;Entry					:
	;	AH=1	Send char in (AL)	:
	;	AH=2	Receive char in (AL)	:
	;	AH=3	Return COM port status	:
	;Exit					:
	;	AX modified			:
	;	All other unchanged		:
	;----------------------------------------

USER_RS232:
     		;Do BIOS call to int 14h
		CLC					;marker for mode being resident

URS232_RETRY:   PUSH	AX				;save entry parms to user RS232 routine
		PUSH	DS
		PUSH	AX
		SUB	AX,AX
		MOV	DS, AX
	ASSUME	DS:ABS0
		AND	BYTE PTR BIOS_BREAK, 07FH	;clear break key depressed bit
		POP	AX
		PUSHF                                   ;go to BIOS RS232 routine
		CALL	DWORD PTR SYSTEM_INT14H		;
		TEST	BYTE PTR BIOS_BREAK, 80H	;is break key depressed?
		POP	DS
		JZ	NO_BREAK_KEY
		OR	AH, 80H				;return unable to transmit status
URS232_EXIT:	ADD	SP,02H                          ;pop entry parms to user rs232 off stack
		IRET
NO_BREAK_KEY:	TEST	AH, 80H				;unable to transmit?
		JZ	URS232_EXIT
		POP	AX				;get back entry parms to user RS232 routine
		JMP 	SHORT URS232_RETRY


	;------ User Printer routine --------------------
	;Entry						:
	;If redirection                                 :
	;	AH=0	send char in (AL)		:
	;	AH<>0	Return PRT port status		:
	;	DX =	index to printer base addresses	:
	;If not redirection				:
	;	Entry parameters are identical to BIOS	:
	;	printer routine				:
	;Exit						:
	;	AX modified				:
	;	All other unchanged			:
	;------------------------------------------------

USER_PIO:	PUSH	AX
		PUSH	DS
		SUB	AX,AX
		MOV	DS,AX
	ASSUME	DS:ABS0
		MOV	AL, BYTE PTR REDIRECTED_TO_SIO
       		CMP	AL, 01H
		POP	DS
		POP	AX
		JZ	DO_REDIRECTION

		;Do BIOS call to int 17h

UPIO_RETRY:   	PUSH	AX				;save entry parms to user PIO routine
		PUSH	DS
		PUSH	AX
		SUB	AX, AX
		MOV	DS, AX
	ASSUME	DS:ABS0
		AND	BYTE PTR BIOS_BREAK, 07FH	;clear break key depressed bit
		POP	AX
		PUSHF                                   ;go to BIOS PIO routine
		CALL	DWORD PTR SYSTEM_INT17H		;
		TEST	BYTE PTR BIOS_BREAK, 80H	;is break key depressed?
		POP	DS
		JZ	NO_BREAK
		OR	AH, 01H				;return unable to print status
UPIO_EXIT:	ADD	SP,02H                          ;pop entry parms to user rs232 off stack
		IRET
NO_BREAK:	TEST	AH, 01H				;unable to print?
		JZ	UPIO_EXIT
		POP	AX				;get back entry parms to user PIO routine
		JMP 	SHORT UPIO_RETRY

DO_REDIRECTION:	PUSH	BX
		PUSH	AX
		PUSH	DX
		CMP	AH, 0				;send char out?
		JZ	OUT_CHAR
		MOV	AH, 03H				;return COM port status
		INT	14H
		AND	AH, 60H				;isolate Tx shift reg empty bit
							;and Tx holding reg empty bit
		CMP	AH, 60H
		JNZ	DO_REDIR1
		MOV	AH, 90H				;set 'not busy'
							; and 'selected' bits on PRT status
		JMP 	SHORT DO_REDIR2
DO_REDIR1:	MOV	AH, 10H				;set 'selected' bit on PRT status
DO_REDIR2:	POP	DX
		JMP 	SHORT DO_REDIR3
OUT_CHAR:	MOV	AH, 01H				;send char in (AL) over COM line
		INT	14H				;
		POP	DX
		TEST	AH, 80H				;time out on?
 		MOV	AH, 90H
		JZ	DO_REDIR3
		MOV	AH, 19H				;set 'selected', I/O error, and
							;timeout bits on PRT status
DO_REDIR3:	POP	BX
		MOV	AL, BL
		POP	BX
		IRET

LAST_ADDRESS	DB	0 				;end of portion that will be loaded

;--------------------------------
;   More Data Definition	:
;--------------------------------

PARM_COPY	DB	15 DUP (0)              	;save parms in that area
END_PARM	LABEL 	BYTE
COMMA_CNT	DB	0				;count # of commas on command line
COM_CMD_BUFFER	DB	'COM'
COM_BUFFER	DB	SPACE,':'					;save
		DB	SPACE,SPACE,SPACE,SPACE,SPACE,COMMA             ;
		DB	SPACE,COMMA,SPACE,COMMA,SPACE,COMMA,SPACE       ;
		DB	CR,LF,'$'					;communication parms here

PRT_BUFFER	DB	'LPT'
		DB	SPACE,':'
		DB 	10 DUP (SPACE)
		DB	CR,LF,'$'

MSG1		DB	'Invalid parameters',CR,LF,CR,LF,'$'
MSG2		DB	'Invalid communication device',CR,LF,CR,LF,'$'
MSG3		DB	'Invalid baud rate',CR,LF,CR,LF,'$'
MSG4		DB	'Infinite retry on parallel printer timeout',CR,LF,CR,LF,'$'
MSG5		DB	'Invalid line printer',CR,LF,CR,LF,'$'
MSG6		DB	'Printer error',CR,LF,CR,LF,'$'
MSG7		DB	'LPT : set for 132 chars/line',CR,LF,CR,LF,'$'
MSG8		DB	'LPT : set for 80 chars/line',CR,LF,CR,LF,'$'
MSG9		DB	'6 lines/inch vertical spacing set',CR,LF,CR,LF,'$'
MSG10		DB	'8 lines/inch vertical spacing set',CR,LF,CR,LF,'$'
MSG11		DB	'LPT#:redirected to COM#',CR,LF,CR,LF,'$'
MSG12		DB	'Resident portion of mode loaded',CR,LF,CR,LF,'$'
MSG13		DB	'Infinite retry on serial device timeout',CR,LF,CR,LF,'$'
MSG14		DB	'Missing hardware',CR,LF,CR,LF,'$'
MSG15		DB	'Non existent printer port',CR,LF,CR,LF,'$'
MSG16		DB	'Non existent serial port',CR,LF,CR,LF,'$'
BAUD_VALUES	DB	'1115306012244896'
ALIGN_TEXT	DB	'0123456789','$'
RIGHT_TEXT	DB	'Do you see the leftmost 0? (Y/N) ','$'
LEFT_TEXT	DB	'Do you see the rightmost 9? (Y/N) ','$'

CURRENT_VIDEO_MODE	DB	?
MAX_COLUMNS		DB	?


;-----------------------:
;	Stack Area	:
;-----------------------:
		DB	100H DUP (?)
TOS		LABEL	BYTE

	;------ Main program starts here

							;At here CS=DS=ES=SS
SETUP_STACK:	MOV	SP, OFFSET TOS			;setup stack
		XOR	CX, CX
		MOV	BX, PARM_AREA
		MOV	CL, [BX]			;get the number of chars
							;(including delimiters)
							;entered after the command name
		JCXZ    INVALID_OPTION
		CALL	GET_PARM                        ;get parameters from command line
	        OR	BYTE PTR PARM_COPY, 20H 	;convert to lower case char
		CMP	BYTE PTR PARM_COPY, 'l'
		JNZ	COM_OPTION
                CALL	SET_PRT				;set mode for line printer
		JMP 	SHORT BACK_TO_DOS

COM_OPTION:	CMP	BYTE PTR PARM_COPY, 'c'
		JNZ	DISPLAY_OPTION
		OR	BYTE PTR PARM_COPY+2, 20H	;CONVERT TO LOWER CASE (add this line on 01/10/85)
		CMP	BYTE PTR PARM_COPY+2, 'm'
		JNZ	DISPLAY_OPTION
		CALL	SET_COM				;set mode for async port
		JMP 	SHORT BACK_TO_DOS

DISPLAY_OPTION:	CALL	SET_DISPLAY			;set mode for display adapter
		JMP 	SHORT BACK_TO_DOS

INVALID_OPTION:	MOV	DX, OFFSET MSG1			;invalid parameters
		MOV	AH, 09H				;
		INT	21H				;

BACK_TO_DOS:    JMP	NO_RESIDENT                     ;This instruction must be a jmp, not jmp short
NO_RESIDENT:	INT	20H 				;return to DOS
STAY_RESIDENT:	MOV	DX, OFFSET LAST_ADDRESS
		INT	27H                     	;return to DOS & stay resident

	;------ End of main program


;-----------------------------------------------:
;		GET_PARM     			:
;Description					:
;	Get input parameters from command line	:
;						:
;-----------------------------------------------:
GET_PARM	PROC
		MOV	SI, PARM_AREA+1  		;set up pointers
		MOV	BX, OFFSET PARM_COPY    	;	/
NEXT_CHAR:	MOV	AL, byte ptr [SI]		;get char from unformated parm area
		CMP	AL, SPACE
		JZ	A2
		CMP	AL, COMMA
		JNZ	A3
		CMP	BYTE PTR COMMA_CNT, 02		;have we seen 2 commas?
		JZ	A4
		CMP	BYTE PTR COMMA_CNT, 01  	;have we seen 1 comma?
		JZ 	A5
		MOV	BYTE PTR COMMA_CNT, 01
		MOV	BX, OFFSET PARM_COPY +10
		JMP 	SHORT A2
A5:		MOV	BYTE PTR COMMA_CNT, 02
		MOV	BX, OFFSET PARM_COPY+11
 		JMP 	SHORT A2
A4:		MOV	BX, OFFSET END_PARM
		JMP 	SHORT A2
A3:		MOV	BYTE PTR [BX], AL       	;save the char, other than space and comma
		INC	BX
A2:		CMP	BX, OFFSET END_PARM		;end of parm area?
		JZ	PARM_EXIT
		INC	SI
		LOOP	NEXT_CHAR
PARM_EXIT:	RET
GET_PARM	ENDP


;-----------------------------------------------:
;		SET_PRT      			:
;Description					:
;	Process printer option			:
;						:
;Entry - <parm_copy> buffer			:
;Exit  - <parm_copy> buffer intact		:
;-----------------------------------------------:


SET_PRT		PROC
		CMP	BYTE PTR PARM_COPY+4, COLON	;valid command?
		JZ	SP_1
		JMP	SP_ERROR

	;check for valid line printer device
SP_1:		MOV	AL, BYTE PTR PARM_COPY+3
		CMP	AL, '1'				;is it LPT1?
		JZ	SP_2
		CMP	AL, '2'				;is it LPT2?
		JZ	SP_2
		CMP	AL, '3'				;is it LPT3?
		JZ	SP_2
		JMP 	SP_ERROR
SP_2:		MOV	BYTE PTR PRT_BUFFER+03H, AL	;save prt device number
		MOV	BYTE PTR MSG7+03H, AL           ;update messages
		MOV	BYTE PTR MSG8+03H, AL           ;

	;check whether printer port corresponding to user selected device exists
		PUSH	SI
		PUSH	DS
		SUB	SI, SI
		MOV	DS, SI
	ASSUME DS:ABS0
		XOR	AH, AH
		MOV	SI, AX                  	;get printer number
		SUB	SI, 31H				;index to printer base address
		SHL	SI, 1                   	;
		CMP	WORD PTR PRINTER_BASE[SI],0
		POP	DS
		POP	SI
	ASSUME DS:CODE
		JNZ	PRT_OPTION
		MOV	DX, OFFSET MSG15        	;non existent printer port
		MOV	AH, 09H
		INT	21H
		JMP 	SP_EXIT

	;check for different options with line printer
PRT_OPTION:	MOV	AL, BYTE PTR PARM_COPY+5
	        CMP	AL, '='
		JNZ	SP_3                    	;go to set line printer
		MOV	BYTE PTR PRT_BUFFER+05H, AL
		PUSH	AX
		PUSH	ES
		SUB	AX,AX
		MOV	ES,AX
	ASSUME ES:ABS0
		MOV	ES:REDIRECTED_TO_SIO, 01H 	;set flag for redirection
		POP	ES
		POP	AX
		CALL	LPT_TO_COM			;redirect printer to serial port
		JMP 	SHORT SP_EXIT

	;set default printer mode
SP_3:           PUSH	AX
		PUSH	ES
		SUB	AX,AX
		MOV	ES,AX
	ASSUME ES:ABS0
		MOV	ES:REDIRECTED_TO_SIO, AL 	;disable redirection
		POP	ES
		POP	AX
           	MOV	WORD PTR PRT_BUFFER+05H, '08'   ;width = 80
		MOV	BYTE PTR PRT_BUFFER+07H, SPACE	;
		MOV	BYTE PTR PRT_BUFFER+08H, COMMA	;
		MOV	BYTE PTR PRT_BUFFER+09H, '6'	;6 lines/inch
		MOV	BYTE PTR PRT_BUFFER+0AH, COMMA

	;set user defined printer mode, if any
		MOV	BX, PARM_AREA+1
		SUB	SI, SI
SP_SCANNING:	CMP	BYTE PTR [BX+SI], SPACE
		JNZ	SP_C2
		INC	SI
		JMP 	SHORT SP_SCANNING
SP_C2:		MOV	BX, PARM_AREA			;get the number of chars typed
		MOV	CL, BYTE PTR [BX]       	;after the command
		XOR	CH, CH
		LEA	BX, [SI+PARM_AREA+6]		;points to line width settings
		CMP	CX, MIN_LPT_CMD             	;valid command?
		JL 	SP_ERR1
		SUB	CX, 05H				;only count parms
 							;starting at line width settings
		MOV	SI, OFFSET PRT_BUFFER+5 	;save user linewidth setting
		MOV	DX, 3                           ;
		CALL	SKIP_BLANK                      ;

		MOV	SI, OFFSET PRT_BUFFER+9         ;save user lines/inch setting
		MOV	DX, 01H                         ;
		CALL	SKIP_BLANK                      ;

		MOV	SI, OFFSET PRT_BUFFER+11        ;save user P option setting
		MOV	DX, 01H                         ;
		CALL	SKIP_BLANK                      ;

		CALL	SET_PRT_PORT
		JMP 	SHORT SP_EXIT

SP_ERROR:	MOV	DX, OFFSET MSG5			;invalid line printer
		MOV	AH, 09H
		INT	21H
		JMP 	SHORT SP_EXIT
SP_ERR1:	MOV	DX, OFFSET MSG1			;invalid parameters
	 	MOV	AH, 09H
		INT	21H
SP_EXIT:	RET
SET_PRT		ENDP

;-----------------------------------------------:
;		LPT_TO_COM			:
;						:
;Description					:
;	Redirection of printer to serial port	:
;-----------------------------------------------:
LPT_TO_COM	PROC

	;check for valid serial ports
		MOV	AL, BYTE PTR PARM_COPY+9	;get COM device number
		CMP	AL, '1'				;is it COM1?
		JZ	LTC1
		CMP	AL, '2'				;is it COM2?
		JZ	LTC1
		JMP 	SHORT LTC_ERROR
LTC1:      	CALL	SET_UP

		MOV	AL, BYTE PTR PARM_COPY+9	;append printer #
		MOV	BYTE PTR MSG11+22, AL   	;and com# to message
		MOV	AL, BYTE PTR PARM_COPY+3	;
		MOV	BYTE PTR MSG11+3, AL    	;
		MOV	DX, OFFSET MSG11        	;LPT# redirected to COM#
		MOV	AH, 09H
		INT	21H
		JMP 	SHORT LTC_EXIT

LTC_ERROR:	MOV	DX, OFFSET MSG2			;illegal COM device
		MOV	AH, 09H
		INT	21H
LTC_EXIT:	RET
LPT_TO_COM	ENDP


;-----------------------------------------------:
;		SET_UP				:
;Description					:
;	Points interrupt vectors 14H, 17H to	:
;	user routines and sets program to exit	:
;	but stay resident.			:
;-----------------------------------------------:
SET_UP		PROC
		PUSH	ES
		PUSH	AX
		PUSH	SI
		SUB	AX, AX
		MOV	ES, AX
	ASSUME ES:ABS0
		LES	DI, DWORD PTR ES:USER_INT14H	;get code segment to user RS232 routine
		MOV	AL, 0F8H                	;marker is 'CLC' instruction
		CMP	AL, BYTE PTR ES:[DI]    	;has MODE utility been already resident?
		JZ	SET_UP_QUIT	        	;go if yes

	        MOV	AH,35H				;get interrupt vector to ROM BIOS RS232 routine
		MOV	AL, 14H				;	/
		INT	21H				;in es:bx
		MOV	SI, ES
		SUB	AX, AX
		MOV	ES, AX
		MOV	ES:SYSTEM_INT14H, BX
		MOV	ES:SYSTEM_INT14H+2, SI

		MOV	AH,35H				;get interrupt vector to ROM BIOS printer i/o
		MOV	AL, 17H				;	/
		INT	21H				;in es:bx
		MOV	SI, ES
		SUB	AX, AX
		MOV	ES, AX
		MOV	ES:SYSTEM_INT17H, BX
		MOV	ES:SYSTEM_INT17H+2, SI

		MOV	AX, OFFSET USER_RS232   	;save pointer to user RS232 routine
		MOV	ES:USER_INT14H, AX      	;
		MOV	AX, CS                  	;
		MOV	ES:USER_INT14H+2,AX     	;

		CLI
		MOV	DX, OFFSET USER_RS232   	;set INT 14H to user routine
		MOV	AH, 25H				;
		MOV	AL, 14H				;
		INT	21H				;

		MOV	DX, OFFSET USER_PIO     	;set INT 17H to user routine
		MOV	AH, 25H				;
		MOV	AL, 17H				;
		INT	21H				;
		STI

	;make code resident by using int 27h
		MOV	BX, OFFSET BACK_TO_DOS+1
		MOV	AX, WORD PTR [BX]
		INC	AX
		INC	AX
		MOV	WORD PTR [BX], AX		;modify jmp address so that it terminates
							;and stays resident (change INT 20H to INT 27H)
		MOV	DX, OFFSET MSG12        	;resident portion of MODE loaded
		MOV	AH, 09H                 	;
		INT	21H                     	;

SET_UP_QUIT:	POP	SI
		POP	AX
		POP	ES
		RET
SET_UP		ENDP


;------------------------------------------------
;		SET_PRT_PORT			:
;Description					:
;	Sets the printer port with user input	:
;	parameters.				:
;------------------------------------------------

SET_PRT_PORT	PROC

	;check for P option (i.e. continuous retry on timeout errors)
		CALL	PRT_P_OPTION

	;set linewidth
		CMP	BYTE PTR PRT_BUFFER+5, '1'
		JNZ	WIDTH80
		CMP	BYTE PTR PRT_BUFFER+6, '3'
		JNZ	WIDTH80
		CMP	BYTE PTR PRT_BUFFER+7, '2'
		JNZ	WIDTH80
		MOV	AX, 0018H			;set 132 chars/line
		CALL	OUT_TO_PRT              	;
		JNZ     SPP_ERROR
		MOV	AX, 000FH			;
		CALL	OUT_TO_PRT              	;
		JNZ	SPP_ERROR
		MOV	DX, OFFSET MSG7
		MOV	AH, 09H
		INT	21H
		JMP 	SHORT LINES_PER_INCH
WIDTH80:	MOV	AX, 0018H			;set 80 chars/line
		CALL	OUT_TO_PRT			;
		JNZ	SPP_ERROR
		MOV	AX, 0012H			;
		CALL	OUT_TO_PRT			;
		JNZ	SPP_ERROR
		MOV	DX, OFFSET MSG8
		MOV	AH, 09H
		INT	21H

	;set lines/inch
LINES_PER_INCH:	CMP	BYTE PTR PRT_BUFFER+9, '8'	;8 lines/inch
		JZ  	SET8
		MOV	AX, 001BH			;set 6 lines/inch
		CALL	OUT_TO_PRT			;
		JNZ	SPP_ERROR               	;
		MOV	AX, 0032H			;
		CALL	OUT_TO_PRT			;
		JNZ	SPP_ERROR               	;
		MOV	DX, OFFSET MSG9         	;
		MOV	AH, 09H                 	;
		INT	21H                     	;
		JMP 	SHORT SPP_EXIT                	;

SET8:		MOV	AX, 001BH			;set 8 lines/inch
		CALL	OUT_TO_PRT			;
		JNZ	SPP_ERROR               	;
		MOV	AX, 0030H			;
		CALL	OUT_TO_PRT			;
		JNZ	SPP_ERROR               	;
		MOV	DX, OFFSET MSG10        	;
		MOV	AH, 09H                 	;
		INT	21H                     	;
		JMP 	SHORT SPP_EXIT                	;

SPP_ERROR:      MOV	DX, OFFSET MSG6         	;printer error
		MOV	AH, 09H
		INT	21H
SPP_EXIT:	RET
SET_PRT_PORT	ENDP

;-------------------------------------------------------:
;		OUT_TO_PRT				:
;Description						:
;	Sends character out to printer			:
;							:
;Entry							:
;	AH = 0  Option to print a character		:
;	AL =    char to print				:
;Exit							:
;	AH <> 0 if character could not be printed.   	:
;	AH =  0 if OK.					:
;-------------------------------------------------------:
;
OUT_TO_PRT	PROC
		XOR	DH, DH
		MOV	DL, BYTE PTR PRT_BUFFER+3	;get device number
		SUB	DL, 31H				;get index to appropriate
							;printer base address
		INT	17H
		AND	AH, 0A9H                        ;report error bits if any
		RET
OUT_TO_PRT	ENDP

;------------------------------------------------
;		PRT_P_OPTION			:
;Description					:
;	Do infinite retry on parallel printer	:
;	timeout if 'p' option selected		:
;------------------------------------------------

PRT_P_OPTION	PROC
		CMP	BYTE PTR PRT_BUFFER+0BH, 70H	;P option?
		JZ	P_OPTION_USED
		MOV	BYTE PTR PRT_BUFFER+0BH, '-'
 		RET

P_OPTION_USED:  CALL	SET_UP 				;point int 14h, int 17h
							;respectively to user RS232 and PIO
							;and make code resident if not has been so
		MOV 	DX, OFFSET MSG4         	;infinte retry on timeout
		MOV	AH, 09H
		INT	21H
		RET
PRT_P_OPTION	ENDP


;-----------------------------------------------:
;		SET_COM      			:
;Description					:
;	Process communication serial port option:
;						:
;Entry - <parm_copy> buffer			:
;Exit  - <parm_copy> buffer intact		:
;-----------------------------------------------:
SET_COM		PROC
		CMP	BYTE PTR PARM_COPY+4, COLON
		JZ	CHECK_VALID_DEVICE
		JMP 	COM_ERR
CHECK_VALID_DEVICE:
		CMP	BYTE PTR PARM_COPY+3, 31H	;is it COM1?
		JZ	C1
		CMP	BYTE PTR PARM_COPY+3, 32H       ;is it COM2?
		JZ	C1
		JMP 	COM_ERR

C1:             MOV	AL, BYTE PTR PARM_COPY+3    	;save com device #
		MOV	COM_BUFFER, AL	            	;	/

	;check whether serial port corresponding to user selected device exists
		PUSH	SI
		PUSH	DS
		SUB	SI, SI
		MOV	DS, SI
	ASSUME DS:ABS0
		XOR	AH, AH
		MOV	SI, AX                  	;get serial port number
		SUB	SI, 31H				;index to RS232 base address
		SHL	SI, 1                   	;
		CMP	WORD PTR RS232_BASE[SI],0
		POP	DS
		POP	SI
	ASSUME	DS:CODE
		JNZ	COM_DEFAULT
		MOV	DX, OFFSET MSG16        	;non existent serial port
		MOV	AH, 09H
		INT	21H
		JMP 	COM_QUIT

		;set default communication parms
COM_DEFAULT:	MOV	BYTE PTR COM_BUFFER+0CH, '1'	;1 stop bit
		MOV	BYTE PTR COM_BUFFER+08H, 'e'	;even parity
		MOV	BYTE PTR COM_BUFFER+0AH, '7'	;data bits=7
		MOV	BYTE PTR COM_BUFFER+0EH, space	;no P option

		MOV	BX, PARM_AREA+1
		SUB	SI, SI
KEEP_SCANNING:	CMP	BYTE PTR [BX+SI], SPACE
		JNZ	C2
		INC	SI
		JMP 	SHORT KEEP_SCANNING
C2:		MOV	BX, PARM_AREA			;get the number of chars typed
		MOV	CL, BYTE PTR [BX]       	;after the command
		XOR	CH, CH
		LEA	BX, [SI+PARM_AREA+6]		;points to baud rate
		CMP	CX, MIN_SIO_CMD             	;valid command?
		JL 	COM_ERR1
		SUB	CX, 05H				;only count parms starting at baud rate
		MOV	SI, OFFSET COM_BUFFER+3
		MOV	DX, 4
		CALL	SKIP_BLANK
		CMP	WORD PTR COM_BUFFER+3, '11'	;is 110 baud rate?
		JNZ	SET_PARITY
		MOV	BYTE PTR COM_BUFFER+0CH, '2'	;default is 2 stop bits
							;for 110 baud rate
SET_PARITY:	MOV	SI, OFFSET COM_BUFFER+8H        ;set parity
		MOV	DX, 01H                         ;       /
		CALL	SKIP_BLANK                      ;       /
		MOV	SI, OFFSET COM_BUFFER+0AH	;set data bits
		MOV	DX, 01H   			;	/
		CALL	SKIP_BLANK                      ;	/
		MOV	SI, OFFSET COM_BUFFER+0CH	;set stop bits
		MOV	DX, 01H				;	/
		CALL	SKIP_BLANK			;	/
		MOV	SI, OFFSET COM_BUFFER+0EH	;p option
		MOV	DX, 01H				;	/
		CALL	SKIP_BLANK			;	/
		CALL	SET_COM_PORT                    ;set RS232 port
							;with user parameters
		JMP 	SHORT COM_QUIT

COM_ERR:	MOV	DX, OFFSET MSG2			;illegal communication device
		MOV	AH, 09
		INT	21H
		JMP 	SHORT COM_QUIT

COM_ERR1: 	MOV	DX, OFFSET MSG1                 ;invalid parameters
		MOV	AH, 09H
		INT	21H
COM_QUIT:	RET
SET_COM		ENDP

;-----------------------------------------------:
;		SKIP_BLANK			:
;Entry						:
;	SI = pointer to where to save 1 parm	:
;	CX = total # of input parms after a 	:
;      	     command				:
;	DX = length of 1 parm			:
;	BX = pointer to where to get 1 parm	:
;Exit						:
;	BX, CX, DX, SI modified			:
;-----------------------------------------------:

SKIP_BLANK	PROC
		OR	CX, CX
		JZ	SKIP_QUIT
SB_NEXT_CHAR:	MOV	AL, [BX]			;get a parm
		INC	BX
		CMP	AL, COMMA			;is it a comma?
		JZ	SKIP_QUIT
		CMP	AL, SPACE			;is it a space?
		JZ	TO_NEXT_CHAR
		CMP	DX, 0           		;end of parm?
		JZ	TO_NEXT_CHAR
		OR	AL, 20H				;convert to lower case
		MOV	BYTE PTR [SI],AL		;save that parm
		DEC	DX
		INC	SI
TO_NEXT_CHAR:	LOOP    SB_NEXT_CHAR
SKIP_QUIT:	RET
SKIP_BLANK	ENDP


;-----------------------------------------------:
;		SET_COM_PORT			:
;Description					:
;	Set the RS232 port with user defined	:
;	parameters				:
;-----------------------------------------------:
SET_COM_PORT	PROC

	;check for P option (i.e. continuous retry on timeout errors)
		CALL	COM_P_OPTION

	;set baud rate
		MOV	DX, WORD PTR COM_BUFFER+03H	;get baud rate
		MOV	BX, OFFSET BAUD_VALUES          ;pointer to look up table
							;for baud rates
		XOR	SI, SI
		MOV	CX, 8				;a total of 8 different baud rates
GET_BAUD_RATE:	CMP	DX, [BX+SI]
		JNZ	NEXT_BAUD_RATE
		MOV	AX, SI 				;pointer to found baud rate
		MOV	WORD PTR COM_BUFFER+05H, '00'	;append '00' to baud rates >=1200
		TEST	AX, 8				;is it < 1200 or >= 1200 baud rate?
		JNZ 	SIO_1
		MOV	WORD PTR COM_BUFFER+05H, 2030H	;append  '0 ' to baud rate less than 1200
SIO_1:          MOV	CL, 04				;set bits 5-7 of (AL) corresponding to
		SHL	AL, CL				;specified baud rate

	;set parity
		CMP	BYTE PTR COM_BUFFER+08H, 'n'	;is parity=none?
		JNZ	SIO_2
		JMP 	SHORT SIO_4
SIO_2:		CMP	BYTE PTR COM_BUFFER+08H, 'o'	;is odd parity?
		JNZ	SIO_3
		OR	AL, 08H				;adjust bits 3-4 for odd parity
		JMP 	SHORT SIO_4
SIO_3:		MOV	BYTE PTR COM_BUFFER+08H, 'e'	;set even parity as default
		OR	AL, 18H				;set bits 3-4 for even parity

	;set stop bits
SIO_4:		CMP	BYTE PTR COM_BUFFER+0CH, '2'	;2 stop bits?
		JNZ	SIO_5
		OR	AL, 04H				;set bit 2 corresponding to 2 stop bits
		JMP 	SHORT SIO_6
SIO_5:		MOV	BYTE PTR COM_BUFFER+0CH, '1'	;1 stop bit
							;bit 2 has been reset for 1 stop bit
	;set length of data
SIO_6:		CMP	BYTE PTR COM_BUFFER+0AH, '8'	;8 data bits?
		JNZ	SIO_7
		OR	AL, 03H                         ;set bits 0-1 for 8 data bits
		JMP 	SHORT SIO_8
SIO_7: 		MOV	BYTE PTR COM_BUFFER+0AH, '7' ;7 data bits as default
		OR	AL, 02H                         ;	/

	;select COM port and initialize it
SIO_8:		CMP	BYTE PTR COM_BUFFER, '2'	;is it COM2?
		JNZ	COM1
		MOV	DX, 01H                         ;select base address for COM2
		JMP 	SHORT INIT_RS232
COM1:		MOV	BYTE PTR COM_BUFFER, '1'        ;it is COM1
		XOR	DX, DX				;select base address for COM1
INIT_RS232:	INT	14H  				;initialize COM port

	;display user settings for COM port
		MOV	DX, OFFSET COM_CMD_BUFFER       ;display user COM parms
		MOV	AH, 09H                         ;
		INT	21H                             ;
		JMP 	SHORT COM_PORT_QUIT

NEXT_BAUD_RATE:	INC	SI
		INC	SI
		DEC	CX
		JZ	INVALID_BAUD_RATE
		JMP	GET_BAUD_RATE

INVALID_BAUD_RATE:
		MOV	DX, OFFSET MSG3			;invalid baud rate
		MOV	AH, 09H                         ;
		INT	21H                             ;
COM_PORT_QUIT:	RET
SET_COM_PORT	ENDP

;------------------------------------------------
;		COM_P_OPTION			:
;Description					:
;	Do infinite retry on serial com. device	:
;	timeout if 'p' option selected		:
;------------------------------------------------

COM_P_OPTION	PROC
		CMP	BYTE PTR COM_BUFFER+0EH, 70H	;P option?
		JZ	COM_P
		MOV	BYTE PTR COM_BUFFER+0EH, '-'
 		RET
COM_P:		CALL	SET_UP           		;setup INT 14H, INT 17H
							;to point to user routines
		MOV 	DX, OFFSET MSG13		;infinte retry on COM timeout errors
		MOV	AH, 09H
		INT	21H
		RET
COM_P_OPTION	ENDP


;------------------------------------------------
;		SET_DISPLAY			:
;						:
;Description					:
;	Process display setting option		:
;						:
;Entry - <parm_copy> buffer			:
;Exit  - <parm_copy> buffer intact		:
;------------------------------------------------
SET_DISPLAY	PROC
		MOV	CX, 4
		XOR	SI, SI
LOW_CASE:	OR	BYTE PTR [PARM_COPY+SI], 20H	;convert to
							;lower case characters
		INC	SI
		LOOP	LOW_CASE

	;case	mode 80
 		CMP	WORD PTR PARM_COPY, '08'
		JNZ	CHECK_MODE40
		CALL	MODE80
		JMP	SHORT SHIFTING_MODE

	;case	mode 40
CHECK_MODE40:	CMP	WORD PTR PARM_COPY, '04'
		JNZ	CHECK_MONO
		CALL	MODE40
		JMP	SHORT SHIFTING_MODE

	;case	mono
CHECK_MONO:	CMP	WORD PTR PARM_COPY, 'om'
		JNZ	CHECK_BW80
		CALL	MONO
		JMP	SHORT SHIFTING_MODE

	;case	BW80
CHECK_BW80:	CMP	WORD PTR PARM_COPY, 'wb'
		JNZ	CHECK_CO80
		CMP	WORD PTR PARM_COPY+2, '08'
		JNZ	CHECK_BW40
		CALL	BW80
		JMP	SHORT SHIFTING_MODE

	;case	BW40
CHECK_BW40:	CMP	WORD PTR PARM_COPY+2, '04'
		JNZ	INVALID
		CALL	BW40
		JMP	SHORT SHIFTING_MODE

	;case	CO80
CHECK_CO80:	CMP	WORD PTR PARM_COPY, 'oc'
		JNZ	CHECK_FOR_INVALID
		CMP	WORD PTR PARM_COPY+2, '08'
		JNZ	CHECK_CO40
		CALL	CO80
		JMP	SHORT SHIFTING_MODE

	;case	CO40
CHECK_CO40:	CMP	WORD PTR PARM_COPY+2, '04'
		JNZ	INVALID
		CALL	CO40
		JMP	SHORT SHIFTING_MODE

	;Check for invalid cases
CHECK_FOR_INVALID:
		CMP	BYTE PTR PARM_COPY, 20H
		JNZ	INVALID

	;case	R,T or L,T
SHIFTING_MODE:	OR	BYTE PTR PARM_COPY+10, 20H	;convert to lower case
		MOV	AL, BYTE PTR PARM_COPY+10
		CMP	AL, 'r'				;shift right?
		JZ	SHIFT_DISPLAY
		CMP	AL, 'l'				;shift left?
		JNZ	SET_DISP_EXIT
SHIFT_DISPLAY:	CALL	ALIGN_SCREEN                      ;shift display left or right
		JMP	SET_DISP_EXIT

	;else	invalid case
INVALID:	MOV	DX, OFFSET MSG1 		;invalid parameters
		MOV	AH, 09H
		INT	21H
SET_DISP_EXIT:	RET
SET_DISPLAY	ENDP


MODE80		PROC
		CALL	VIDEO_STATE     		;get current video state
		OR	AL, 02H         		;set mode 80
		MOV	AH, 0H				;
		INT	10H				;
		RET
MODE80		ENDP


MODE40		PROC
		CALL	VIDEO_STATE     		;get current video state
		AND	AL, 01H         		;set mode 40
		MOV	AH, 0H				;
		INT	10H				;
		RET
MODE40		ENDP


MONO		PROC
		MOV	CL, 30H				;video bits to be updated in <equip_flag>
		MOV	CH, 02H         		;mode 80x25 BW
		MOV	BX, 0B000H			;beginning of monochrome display adapter
		CALL	VIDEO_RAM_ACCESS
		RET
MONO		ENDP


BW80		PROC
		MOV	CL, 20H				;video bits to be updated in <equip_flag>
		MOV	CH, 02H         		;mode 80x25 BW graphics
		MOV	BX, 0B800H			;beginning of color graphic display adapter
		CALL	VIDEO_RAM_ACCESS
		RET
BW80		ENDP


BW40		PROC
		MOV	CL, 10H         		;video bits to be updated in <equip_flag>
		MOV	CH, 00H         		;mode 40x25 BW graphics
		MOV	BX, 0B800H			;beginning of color graphic display adapter
		CALL	VIDEO_RAM_ACCESS
		RET
BW40		ENDP


CO80		PROC
		MOV	CL, 20H				;video bits to be updated in <equip_flag>
		MOV	CH, 03H         		;mode 80x25 color
		MOV	BX, 0B800H			;beginning of color graphic display adapter
		CALL	VIDEO_RAM_ACCESS
		RET
CO80		ENDP


CO40		PROC
		MOV	CL, 10H				;video bits to be updated in <equip_flag>
		MOV	CH, 01H         		;mode 40x25 BW
		MOV	BX, 0B800H			;beginning of color graphic display adapter
		CALL	VIDEO_RAM_ACCESS
		RET
CO40		ENDP




VIDEO_STATE	PROC
		MOV	AX, 0F00H			;get current video mode
		INT	10H
		RET
VIDEO_STATE	ENDP

;----------------------------------------
; 	VIDEO_RAM_ACCESS		:
;Entry					:
;	BX = pointer to display buffer	:
;	CH = video mode to be set	:
;	CL = video bits to be updated in:
;		<equip_flag>		:
;Exit					:
;	BX, CX unaffected		:
;	<equip_flag> updated		:
;----------------------------------------

VIDEO_RAM_ACCESS	PROC
		PUSH	DS
		MOV	DS, BX                  	;DS=display buffer
		XOR	SI, SI
		MOV	DH, BYTE PTR [SI]		;get a byte
		MOV	AL, 0AAH			;write pattern 0AAH in
		MOV	BYTE PTR [SI], AL		;
		MOV	AH, BYTE PTR [SI]		;read it back
		MOV	BYTE PTR [SI], DH		;restore previous byte
		POP	DS
		CMP	AH, AL				;do read and write match?
		JNZ	NO_ACCESS
		CALL	INIT_MODE
		RET
NO_ACCESS:	MOV	DX, OFFSET MSG14		;no video RAM access capability
		MOV	AH, 09H				;
		INT	21H                     	;
		RET
VIDEO_RAM_ACCESS	ENDP

;----------------------------------------
;		INIT_MODE		:
;					:
;Entry					:
;	CH = video mode to be set	:
;	CL = video bits to be updated in:
;		<equip_flag>		:
;	<equip_flag>			:
;Exit					:
;	CX unaffected			:
;	<equip_flag> updated		:
;----------------------------------------

INIT_MODE	PROC
		PUSH	DS
		SUB	AX, AX
		MOV	DS, AX
	ASSUME DS:ABS0
		MOV	AX, WORD PTR EQUIP_FLAG
		AND	AL, 0CFH			;disable video bits 4-5
		OR	AL, CL
		MOV	WORD PTR EQUIP_FLAG,AX		;update equip flag
 		MOV	AH, 0H 				;set mode
		MOV	AL, CH				;
		INT	10H				;
		MOV	AH, 02H				;set cursor at (0,0)
		SUB	DX, DX				;
		INT	10H				;
		POP	DS
		RET
INIT_MODE	ENDP


ALIGN_SCREEN	PROC
	ASSUME DS:CODE
AGAIN:  	PUSH	ES			;SAVE FOR LATER
		CALL	SET_UP			;make code resident and point INTR vectors

	        MOV	AH, 35H			;get interrupt vector to ROM BIOS VIDEO PARM TABLE
		MOV	AL, 1DH			;	/
		INT	21H			;in es:bx
                MOV	CX, ES
                MOV	BP, OFFSET USER_VIDEO_PARM
                SUB	AX, AX
		MOV	DS, AX
	ASSUME DS:ABS0
        	MOV	AX, [USER_INT14H+2]	;get segment part address of user INT14H routine
                MOV	ES, AX			;save it
                CMP	CX, AX			;is user video parm table resident yet?
                JZ	USER_VIDEO_PARM_RESIDENT
;*              MOV	AX, CS 			;vqt
		MOV	DS, AX
	ASSUME DS:CODE
	;* point vector 1dh to user video parms
		CLI
		MOV	DX, OFFSET USER_VIDEO_PARM	;set INT 1DH to user video parm table
		MOV	AH, 25H				;
		MOV	AL, 1DH				;
		INT	21H				;
	;* move system video_parm table to user video parm table
        	MOV	SI, BX				;DS:SI --> SYSTEM VIDEO PARM
                MOV	DS, CX				;
                MOV	DI, BP
		MOV	CX, 32
	REP	MOVSW
		STI
USER_VIDEO_PARM_RESIDENT:

		PUSH	ES 			;DS --> segment part address of user video parm
		POP	DS  			;
                POP	ES
                MOV	SI, BP			;SI = offset part address of user video parm

		CMP	CS:BYTE PTR PARM_COPY+10, 'r'	;shift right?
		JZ 	RIGHT_MODIFY_TABLE
	;* Modify user video parm table for shift left option
						;AT HERE, DS:SI--> USER VIDEO PARM TABLE
		MOV	AL, BYTE PTR [SI+02]
		INC	AL
		MOV	BYTE PTR [SI+02], AL
		MOV	AL, BYTE PTR [SI+12H]
		ADD	AL, 02
		MOV	BYTE PTR [SI+12H], AL
		MOV	AL, BYTE PTR [SI+22H]
		INC	AL
		MOV	BYTE PTR [SI+22H], AL
		JMP 	CURRENT_MODE
RIGHT_MODIFY_TABLE:
	;* Modify user video parm table for shift right option
		MOV	AL, BYTE PTR [SI+02]
		DEC	AL
		MOV	BYTE PTR [SI+02], AL
		MOV	AL, BYTE PTR [SI+12H]
		SUB	AL, 02
		MOV	BYTE PTR [SI+12H], AL
		MOV	AL, BYTE PTR [SI+22H]
		DEC	AL
		MOV	BYTE PTR [SI+22H], AL

CURRENT_MODE:	MOV	AX, CS
		MOV	DS, AX
        ASSUME DS:CODE
		MOV	AH, 0FH				;get current video state
		MOV	AL, 0				;
		INT	10H				;
		MOV	[CURRENT_VIDEO_MODE], AL	;save for later use
		MOV	[MAX_COLUMNS], AH               ;
		MOV	AH, 0				;set video mode
		INT	10H                         	;

		OR	BYTE PTR PARM_COPY+11, 20H	;convert to lower case
		CMP	BYTE PTR PARM_COPY+11, 't'	;are we displaying a test pattern?
		JNZ	ALIGN_EXIT
		MOV	CX, 8                     	;display pattern
		CMP	[MAX_COLUMNS], 40               ;
		JNZ	V1		                ;
		SHR	CX, 1                           ;
V1:		MOV	DX, OFFSET ALIGN_TEXT           ;
		MOV	AH, 09H                         ;
		INT	21H                             ;
		LOOP	V1		 	        ;

		MOV	DX, OFFSET RIGHT_TEXT           ;display text
		CMP	BYTE PTR PARM_COPY+10, 'r'      ;
		JZ	V2 		                ;
		MOV     DX, OFFSET LEFT_TEXT            ;
V2:		MOV	AH, 09H                         ;
		INT	21H                             ;

		MOV	AH, 0CH				;clear keyboard buffer and
		MOV	AL, 01H				;and wait for input
		INT	21H				;
		OR	AL, 20H				;convert input response to lower case
		CMP	AL, 'y'				;yes option?
		JZ	ALIGN_EXIT
		JMP	AGAIN
ALIGN_EXIT:	RET
ALIGN_SCREEN	ENDP






CODE		ENDS
		END     START
