rem	Batch file to copy a predefined group of files from current
rem	directory to target directory.  A group is either all essential
rem	files of a selected MS-DOS utility or all MS-DOS files which
rem	are needed to make a release.
rem
rem	This makes it easy to isolate and control changed files when
rem	fixing a utility.
rem
rem	Parameters:	Selected group   = %1
rem			Target directory = %2
echo off
rem
rem	This is intended to be used as follows:
rem	1.  Restore all files from archived MSDOS disks into directory
rem	    DOS16.
rem	2.  Create workspace (subdirectory) for utility that needs fixing.
rem	3.  Use TRANSFER to put all files into this workspace.
rem	4.  Fix files and test.
rem	5.  Update TRANSFER.BAT if new files have been created in workspace.
rem	6.  Compare all files in workspace with files in DOS16 to identify
rem	    changed files.  Carefully check TRANSFER.BAT to make sure that
rem	    these changed files are NOT used to create any other utility.
rem	    If these changed files are used to create another utility,
rem	    check for possible side-effects or change name of this file.
rem	7.  TRANSFER files back into DOS16.
rem	8.  Archive DOS16, increase rev level,
rem	    and put into document control library.
rem

if not %1==ansi  goto a
copy ansi.asm %2
copy ansi.bat %2
copy ansi.doc %2
copy ansi.sys %2
copy EXE2BIN.EXE %2
copy LINK.EXE %2
copy MASM.EXE %2
goto end

:a
if not %1==loader  goto b
copy EXE2BIN.EXE %2
copy LINK.EXE %2
copy LOADER.ASM %2
copy LOADER.BAT %2
copy LOADER.BIN %2
copy MASM.EXE %2
goto end

:b
if not %1==chkdsk  goto c
copy CHKDSK.ASM %2
copy CHKDSK.COM %2
copy CHKDSKMK.BAT %2
copy CHKMES.ASM %2
copy CHKPROC.ASM %2
copy DOSMAC.ASM %2
copy DOSSYM.ASM %2
copy EXE2BIN.EXE %2
copy LINK.EXE %2
copy MASM.EXE %2
goto end

:c
if not %1==command  goto d
copy COMEQU.ASM %2
copy COMLINK %2
copy COMMAKE.BAT %2
copy COMMAND.ASM %2
copy COMSEG.ASM %2
copy COMSW.ASM %2
copy COPY.ASM %2
copy COPYPROC.ASM %2
copy CPARSE.ASM %2
copy DEVSYM.ASM %2
copy DOSMAC.ASM %2
copy DOSSYM.ASM %2
copy EXE2BIN.EXE %2
copy EXEC.ASM %2
copy IFEQU.ASM %2
copy INIT.ASM %2
copy LINK.EXE %2
copy MASM.EXE %2
copy RDATA.ASM %2
copy RUCODE.ASM %2
copy TCODE.ASM %2
copy TCODE2.ASM %2
copy TCODE3.ASM %2
copy TCODE4.ASM %2
copy TCODE5.ASM %2
copy TDATA.ASM %2
copy TSPC.ASM %2
copy TUCODE.ASM %2
copy UINIT.ASM %2
goto end

:d
if not %1==debug  goto e
copy DEBASM.ASM %2
copy DEBCOM1.ASM %2
copy DEBCOM2.ASM %2
copy DEBCONST.ASM %2
copy DEBDATA.ASM %2
copy DEBEQU.ASM %2
copy DEBLINK %2
copy DEBMAKE.BAT %2
copy DEBMES.ASM %2
copy DEBUASM.ASM %2
copy DEBUG.ASM %2
copy DEBUG.COM %2
copy DOSMAC.ASM %2
copy DOSSYM.ASM %2
copy EXE2BIN.EXE %2
copy LINK.EXE %2
copy MASM.EXE %2
goto end

:e
if not %1==diskcomp  goto f
copy DISKCOMP.ASM %2
copy DISKCOMP.COM %2
copy DOSMAC.ASM %2
copy DOSSYM.ASM %2
copy EXE2BIN.EXE %2
copy LINK.EXE %2
copy MAKECOMP.BAT %2
copy MASM.EXE %2
goto end

:f
if not %1==diskcopy  goto g
copy DISKCOPY.ASM %2
copy DISKCOPY.COM %2
copy DISKMES.ASM %2
copy DOFORMAT.ASM %2
copy DOSMAC.ASM %2
copy DOSSYM.ASM %2
copy EXE2BIN.EXE %2
copy LINK.EXE %2
copy MASM.EXE %2
copy MKCOPY.BAT %2
goto end

:g
if not %1==msdos  goto h
copy ALLOC.ASM %2
copy BUF.ASM %2
copy CTRLC.ASM %2
copy DEV.ASM %2
copy DEVSYM.ASM %2
copy DIR.ASM %2
copy DIRCALL.ASM %2
copy DISK.ASM %2
copy DOSLINK %2
copy DOSMAC.ASM %2
copy DOSMAKE.BAT %2
copy DOSMES.ASM %2
copy DOSPATCH.TXT %2
copy DOSSEG.ASM %2
copy DOSSYM.ASM %2
copy EXE2BIN.EXE %2
copy EXEC.ASM %2
copy FAT.ASM %2
copy FCB.ASM %2
copy GETSET.ASM %2
copy IO.ASM %2
copy LINK.EXE %2
copy MASM.EXE %2
copy MISC.ASM %2
copy MSCODE.ASM %2
copy MSDATA.ASM %2
copy MSDOS.ASM %2
copy MSDOS.SYS %2
copy MSHEAD.ASM %2
copy MSINIT.ASM %2
copy PROC.ASM %2
copy ROM.ASM %2
copy STDBUF.ASM %2
copy STDCALL.ASM %2
copy STDCTRLC.ASM %2
copy STDFCB.ASM %2
copy STDIO.ASM %2
copy STDPROC.ASM %2
copy STDSW.ASM %2
copy STRIN.ASM %2
copy SYSCALL.ASM %2
copy TIME.ASM %2
copy XENIX.ASM %2
copy XENIX2.ASM %2
goto end

:h
if not %1==edlin  goto i
copy DOSMAC.ASM %2
copy DOSSYM.ASM %2
copy EDLIN.ASM %2
copy EDLIN.COM %2
copy EDLLINK %2
copy EDLMAKE.BAT %2
copy EDLMES.ASM %2
copy EDLPROC.ASM %2
copy EXE2BIN.EXE %2
copy LINK.EXE %2
copy MASM.EXE %2
goto end

:i
if not %1==epsonbio  goto j
copy BIOS.INP %2
copy BIOSGEN.DOC %2
copy COMMAND.COM %2
copy DEBUG.COM %2
copy DEVSYM.ASM %2
copy DOSMAC.ASM %2
copy DOSSYM.ASM %2
copy EPSONBIO.ASM %2
copy EPSONBIO.BIN %2
copy EXE2BIN.EXE %2
copy FORMAT.COM %2
copy FORMAT.INP %2
copy HARD.ASM %2
copy HARDHEAD.ASM %2
copy HIDDEN.INP %2
copy INSTALL.BAT %2
copy LINK.EXE %2
copy LOADER.BIN %2
copy LOADER.INP %2
copy MAKEBIOS.BAT %2
copy MASM.EXE %2
copy MSDOS.SYS %2
copy STARTHD.DOC %2
copy SYSIMES.ASM %2
copy SYSINIT.ASM %2
goto end

:j
if not %1==exe2bin  goto k
copy DOSMAC.ASM %2
copy DOSSYM.ASM %2
copy EXE2BIN.ASM %2
copy EXE2BIN.EXE %2
copy EXEBINMK.BAT %2
copy EXEMES.ASM %2
copy LINK.EXE %2
copy MASM.EXE %2
goto end

:k
if not %1==fc  goto l
copy DOSMAC.ASM %2
copy DOSSYM.ASM %2
copy FC.ASM %2
copy FC.EXE %2
copy FCMAKE.BAT %2
copy FCMES.ASM %2
copy LINK.EXE %2
copy MASM.EXE %2
goto end

:l
if not %1==find  goto m
copy DOSMAC.ASM %2
copy DOSSYM.ASM %2
copy FIND.ASM %2
copy FIND.EXE %2
copy FINDMAKE.BAT %2
copy FINDMES.ASM %2
copy LINK.EXE %2
copy MASM.EXE %2
goto end

:m
if not %1==format  goto n
copy DEBUG.COM %2
copy DOSMAC.ASM %2
copy DOSSYM.ASM %2
copy EXE2BIN.EXE %2
copy FORMAT.ASM %2
copy FORMAT.COM %2
copy FORMAT.DOC %2
copy FORMES.ASM %2
copy LINK.EXE %2
copy LOADER.BIN %2
copy MASM.EXE %2
copy MKFORM.BAT %2
copy MKFORM.DOC %2
copy MKFORM.INP %2
copy VFORMAT.ASM %2
goto end

:n
if not %1==mode  goto o
copy EXE2BIN.EXE %2
copy LINK.EXE %2
copy MASM.EXE %2
copy MODE.ASM %2
copy MODE.BAT %2
copy MODE.COM %2
goto end

:o
if not %1==more  goto p
copy DOSMAC.ASM %2
copy DOSSYM.ASM %2
copy EXE2BIN.EXE %2
copy LINK.EXE %2
copy MASM.EXE %2
copy MORE.ASM %2
copy MORE.COM %2
copy MOREMAKE.BAT %2
copy MOREMES.ASM %2
goto end

:p
if not %1==print  goto q
copy DOSMAC.ASM %2
copy DOSSYM.ASM %2
copy EXE2BIN.EXE %2
copy LINK.EXE %2
copy MASM.EXE %2
copy PRINT.ASM %2
copy PRINT.COM %2
copy PRINTMK.BAT %2
goto end

:q
if not %1==recover  goto r
copy DOSMAC.ASM %2
copy DOSSYM.ASM %2
copy EXE2BIN.EXE %2
copy LINK.EXE %2
copy MASM.EXE %2
copy RECMAKE.BAT %2
copy RECMES.ASM %2
copy RECOVER.ASM %2
copy RECOVER.COM %2
goto end

:r
if not %1==sort  goto s
copy DEVSYM.ASM %2
copy DOSMAC.ASM %2
copy DOSSYM.ASM %2
copy LINK.EXE %2
copy MASM.EXE %2
copy SORT.ASM %2
copy SORT.EXE %2
copy SORTFIX %2
copy SORTMAKE.BAT %2
copy SORTMES.ASM %2
goto end

:s
if not %1==sys  goto t
copy DEVSYM.ASM %2
copy DOSMAC.ASM %2
copy DOSSYM.ASM %2
copy EXE2BIN.EXE %2
copy LINK.EXE %2
copy MASM.EXE %2
copy SYS.ASM %2
copy SYS.COM %2
copy SYSMAKE.BAT %2
copy SYSMAKE2.BAT %2
copy SYSMES.ASM %2
goto end

:t
if not %1==release  goto u
copy ANSI.SYS %2
copy CHKDSK.COM %2
copy COMMAND.COM %2
copy DEBUG.COM %2
copy DISKCOMP.COM %2
copy DISKCOPY.COM %2
copy EDLIN.COM %2
copy epsonbio.bin %2
copy EXE2BIN.EXE %2
copy FC.EXE %2
copy FIND.EXE %2
copy FORMAT.COM %2
copy LINK.EXE %2
copy LOADER.BIN %2
copy MODE.COM %2
copy MORE.COM %2
copy msdos.sys %2
copy PRINT.COM %2
copy RECOVER.COM %2
copy SORT.EXE %2
copy SYS.COM %2
goto end

:u
echo on
rem UTILITY NAME NOT RECOGNIZED
:end
